--------------------------------------------------------------------------
--  Forest library, version 1.2						--
--  Copyright (C) 1995 by Kenneth Almquist				--
--									--
--  You may redistribute or modify this software under the terms	--
--  given in the License for the Forest Library, which appears in	--
--  the file named LICENSE.						--
--------------------------------------------------------------------------

package body POSIX.POSIX_Private is

function Values(Arg_List: POSIX_String_List) return Argv_Array is
    Argv: Argv_Array (1 .. Length(Arg_List) + 1);
    P: POSIX_String_List_Entry_Ptr;
begin
    P := Arg_List.Values;
    for I in Argv'first .. Argv'last - 1 loop
	-- With GNAT 2.02, p.value'first is not reliable.  So we
	-- use p.first instead.
	Argv(I) := P.Value(P.First)'address;
	P := P.Next;
    end loop;
    Argv(Argv'last) := System.Null_Address;
    pragma assert(P = null);
    return Argv;
end Values;
pragma inline(Values);

end POSIX.POSIX_Private;
