--------------------------------------------------------------------------
--  Forest library, version 1.2						--
--  Copyright (C) 1995 by Kenneth Almquist				--
--									--
--  You may redistribute or modify this software under the terms	--
--  given in the License for the Forest Library, which appears in	--
--  the file named LICENSE.						--
--------------------------------------------------------------------------

package POSIX_Process_Identification.More is

    Super_User_ID: constant User_ID;
	-- The user ID of the super-user.

    function Process_ID_To_Integer(Process_ID: Process_ID) return Integer;
	-- Exceptions:  none.
	-- Convert a process ID to an integer.  Intended mainly for use
	-- internally by Forest, but there is no harm in clients using
	-- this as well.

    function Integer_To_Process_ID(int: Integer) return Process_ID;
	-- Exceptions:  none.
	-- Convert a process ID to an integer.  Intended mainly for use
	-- internally by Forest, but there is no harm in clients using
	-- this as well.

    function Process_Group_ID_To_Integer(Group: Process_Group_ID) return Integer;
	-- Exceptions:  none.
	-- Convert a process group ID to an integer.  Intended mainly for
	-- use internally by Forest, but there is no harm in clients using
	-- this as well.

private
    Super_User_ID: constant User_ID := 0;
end POSIX_Process_Identification.More;
