--------------------------------------------------------------------------
--  Copyright (C) 1995 by Kenneth Almquist				--
--									--
--  This program is free software; you can redistribute it and/or	--
--  modify it under the terms of the GNU General Public License as	--
--  published by the Free Software Foundation; either version 2 of	--
--  the License, or (at your option) any later version.			--
--------------------------------------------------------------------------

with text_io; use text_io;
package body test_pkg is

procedure test(label: string) is
begin
    put("Test "); put(label); new_line;
end test;


procedure fail is
begin
    put("Test failed."); new_line;
    error_count := error_count + 1;
end fail;

procedure fail(message: string) is
begin
    put("Test failed: "); put(message); new_line;
    error_count := error_count + 1;
end fail;


procedure require(condition: boolean) is
begin
    if not condition then
	fail("require");
    end if;
end require;


procedure require(condition: boolean; message: string) is
begin
    if not condition then
	fail(message);
    end if;
end require;


procedure except is
begin
    fail("Exception expected");
end except;


procedure check_error(expect: posix.error_code) is
    e: posix.error_code := posix.get_error_code;
begin
    if e /= expect then
	fail("Error code is " & posix.image(e));
	put_line("      Expected error code: " & posix.image(expect));
    end if;
end check_error;


procedure done is
begin
    new_line;
    if error_count = 0 then
	put("Tests completed successfully.");
    else
	put("Tests finished:"); put(natural'image(error_count));
	put(" error");
	if error_count /= 1 then put('s'); end if;
    end if;
    new_line;
end done;

end test_pkg;
