/*
 * Copyright (C) 1995 by Kenneth Almquist
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of
 *  the License, or (at your option) any later version.
 */

/*
 * This program calculates some information about the C integral types.
 * In GCC these are defined in header files for each system that GCC runs
 * on.  Since we don't perform the GCC configuration step, we compute the
 * values here.  The results are stored (by the makefile) in the host.h
 * which is included by config.h.
 */

#include <stdio.h>

#define COUNT_BITS(x)	{ nbits = 0; for (x = 1 ; x != 0 ; x <<= 1) nbits++; }


main(argc, argv)  char **argv; {
    int nbits;
    unsigned char uchar;
    unsigned short ushort;
    unsigned int uint;
    unsigned long ulong;
    char plain_char;
    char zero = 0;
    int big_endian;

    COUNT_BITS(uchar);
    printf("#define HOST_BITS_PER_CHAR %d\n", nbits);
    COUNT_BITS(ushort);
    printf("#define HOST_BITS_PER_SHORT %d\n", nbits);
    COUNT_BITS(uint);
    printf("#define HOST_BITS_PER_INT %d\n", nbits);
    COUNT_BITS(ulong);
    printf("#define HOST_BITS_PER_LONG %d\n", nbits);
    plain_char = -1;
    printf("#define DEFAULT_SIGNED_CHAR %d\n", plain_char < zero);
    uint = 1;
    big_endian = *(unsigned char *) &uint == 0;
    printf("#define BYTES_BIG_ENDIAN %d\n", big_endian);
    printf("#define WORDS_BIG_ENDIAN %d\n", big_endian);
    exit(0);
}
