divert(-1)
##########################################################################
##  Forest library, version 1.3						##
##  Copyright (C) 1995 by Kenneth Almquist				##
##									##
##  You may redistribute or modify this software under the terms	##
##  given in the License for the Forest Library, which appears in	##
##  the file named LICENSE.						##
##########################################################################

[This file contains definitions of the error code values.  The macro
    _posix_error(name, value)
is called for each error code defined by POSIX.  The macro
    _local_error(name, value)
is called for error codes which are extensions to POSIX.  To use this
file, define the above macros and then include this file.  The macros
below ensure that these won't be called for undefined error codes.]

define([_posix], [ifdef([$2], [_posix_error([$1], $2)], [Error: $2 undefined])])
define([_local], [ifdef([$2], [_local_error([$1], $2)], [dnl])])
divert(0)dnl
_posix_error([No_Error], 0)
_posix([Argument_List_Too_Long], [E2BIG])
_posix([Bad_File_Descriptor], [EBADF])
_posix([Broken_Pipe], [EPIPE])
_posix([Directory_Not_Empty], [ENOTEMPTY])
_posix([Exec_Format_Error], [ENOEXEC])
_posix([File_Exists], [EEXIST])
_posix([File_Too_Large], [EFBIG])
_posix([Filename_Too_Long], [ENAMETOOLONG])
_posix([Improper_Link], [EXDEV])
_posix([Inappropriate_IO_Control_Operation], [ENOTTY])
_posix([Input_Output_Error], [EIO])
_posix([Interrupted_Operation], [EINTR])
_posix([Invalid_Argument], [EINVAL])
_posix([Invalid_Seek], [ESPIPE])
_posix([Is_A_Directory], [EISDIR])
_posix([No_Child_Process], [ECHILD])
_posix([No_Locks_Available], [ENOLCK])
_posix([No_Space_Left_On_Device], [ENOSPC])
_posix([No_Such_Operation_On_Device], [ENODEV])
_posix([No_Such_Device_Or_Address], [ENXIO])
_posix([No_Such_File_Or_Directory], [ENOENT])
_posix([No_Such_Process], [ESRCH])
_posix([Not_A_Directory], [ENOTDIR])
_posix([Not_Enough_Space], [ENOMEM])
_posix([Operation_Not_Implemented], [ENOSYS])
_posix([Operation_Not_Permitted], [EPERM])
_posix([Permission_Denied], [EACCES])
_posix([Read_Only_File_System], [EROFS])
_posix([Resource_Busy], [EBUSY])
_posix([Resource_Deadlock_Avoided], [EDEADLK])
_posix([Resource_Temporarily_Unavailable], [EAGAIN])
_posix([Too_Many_Links], [EMLINK])
_posix([Too_Many_Open_Files], [EMFILE])
_posix([Too_Many_Open_Files_In_System], [ENFILE])
_local([Argument_Too_Large], [EDOM])
_local([Result_Too_Large], [ERANGE])
ifelse(EWOULDBLOCK, EAGAIN, [dnl], [_local([Operation_Would_Block], [EWOULDBLOCK])])
_local([Operation_Now_In_Progress], [EINPROGRESS])
_local([Operation_Already_In_Progress], [EALREADY])
_local([Socket_Operation_On_Nonsocket], [ENOTSOCK])
_local([Destination_Address_Required], [EDESTADDRREQ])
_local([Message_Too_Long], [EMSGSIZE])
_local([Protocol_Wrong_Type_For_Socket], [EPROTOTYPE])
_local([Protocol_Not_Available], [ENOPROTOOPT])
_local([Protocol_Not_Supported], [EPROTONOSUPPORT])
_local([Socket_Type_Not_Supported], [ESOCKTNOSUPPORT])
_local([Operation_Not_Supported_On_Socket], [EOPNOTSUPP])
_local([Protocol_Family_Not_Supported], [EPFNOSUPPORT])
_local([Address_Family_Not_Supported_By_Protocol_Family], [EAFNOSUPPORT])
_local([Address_Already_In_Use], [EADDRINUSE])
_local([Cannott_Assign_Requested_Address], [EADDRNOTAVAIL])
_local([Network_Is_Down], [ENETDOWN])
_local([Network_Is_Unreachable], [ENETUNREACH])
_local([Network_Dropped_Connection_On_Reset], [ENETRESET])
_local([Software_Caused_Connection_Abort], [ECONNABORTED])
_local([Connection_Reset_By_Peer], [ECONNRESET])
_local([No_Buffer_Space_Available], [ENOBUFS])
_local([Socket_Is_Already_Connected], [EISCONN])
_local([Socket_Is_Not_Connected], [ENOTCONN])
_local([Send_After_Socket_Shutdown], [ESHUTDOWN])
_local([Too_Many_References], [ETOOMANYREFS])
_local([Connection_Timed_Out], [ETIMEDOUT])
_local([Connection_Refused], [ECONNREFUSED])
_local([Too_Many_Levels_Of_Symbolic_Links], [ELOOP])
dnl _local([File_Name_Too_Long], [ENAMETOOLONG])
_local([Host_Is_Down], [EHOSTDOWN])
_local([No_Route_To_Host], [EHOSTUNREACH])
_local([Too_Many_Processes], [EPROCLIM])
_local([Too_Many_Users], [EUSERS])
_local([Disc_Quota_Exceeded], [EDQUOT])
_local([Stale_NFS_File_Handle], [ESTALE])
_local([Too_Many_Levels_Of_Remote_In_Path], [EREMOTE])
_local([Not_A_Stream], [ENOSTR])
_local([No_Data_Available], [ENODATA])
_local([Timer_Expired], [ETIME])
_local([Out_Of_Streams_Resources], [ENOSR])
_local([No_Message_Of_Desired_Type], [ENOMSG])
_local([Not_A_Data_Message], [EBADMSG])
_local([Identifier_Removed], [EIDRM])
dnl _local([No_Record_Locks_Available], [ENOLCK])
_local([Machine_Is_Not_On_The_Network], [ENONET])
_local([Object_Is_Remote], [ERREMOTE])
_local([Link_Has_Been_Severed], [ENOLINK])
_local([Advertise_Error], [EADV])
_local([Srmount_Error], [ESRMNT])
_local([Communication_Error_On_Send], [ECOMM])
_local([Protocol_Error], [EPROTO])
_local([Multihop_Attempted], [EMULTIHOP])
_local([Cross_Mount_Point], [EDOTDOT])
_local([Remote_Address_Changed], [EREMCHG])
_local([Cannot_Access_Shared_Library], [ELIBACC])
_local([Corrupted_Shared_Library], [ELIBBAD])
undefine([_posix])undefine([_local])dnl
