--------------------------------------------------------------------------
--  Forest library, version 1.3						--
--  Copyright (C) 1995 by Kenneth Almquist				--
--									--
--  You may redistribute or modify this software under the terms	--
--  given in the License for the Forest Library, which appears in	--
--  the file named LICENSE.						--
--------------------------------------------------------------------------

package body POSIX_Private_1 is

function Empty_Set return Option_Set is
begin
    return (Bits => 0);
end Empty_Set;

function "+" (L, R: Option_Set) return Option_Set is
begin
    return (Bits => L.Bits or R.Bits);
end "+";

function "-" (L, R: Option_Set) return Option_Set is
begin
    return (Bits => L.Bits and not R.Bits);
end "-";


function Get_Option_Bits(Set: Option_Set) return Option_Bits is
begin
    return Set.Bits;
end Get_Option_Bits;

function Make_Option_Set(Bits: Option_Bits) return Option_Set is
begin
    return (Bits => Bits);
end Make_Option_Set;

function Option_Present(Set: Option_Set; Option: Option_Set) return Boolean is
begin
    return (Set.Bits and Option.Bits) /= 0;
end;

end POSIX_Private_1;
