divert(-1)
##########################################################################
##  Forest library, version 1.4beta					##
##  Copyright (C) 1995 by Kenneth Almquist				##
##									##
##  You may redistribute or modify this software under the terms	##
##  given in the License for the Forest Library, which appears in	##
##  the file named LICENSE.						##
##########################################################################

# This file contains definitions used by m4.  We treat quoted strings as
# comments so that substitutions will not occur inside of them.  We use
# [ and ] for quoting since these characters are not used in Ada.

changecom(", ")
changequote([, ])

[
Conditional macros.  These are like #ifdef/#if/#else/#endif in C except
that they divert the output rather than discarding it, so m4 macros are
still evaluated.  These macros assume that, except for them, output is
diverted to 0.  Example:
_ifdef([IF_SOCK])
_if(IF_SOCK == 0)
   return false;
_else
   return (mode and IF_SOCK) /= 0;
_endif
_else
   return false;
_endif
]

[A stack of conditions.]
define([condstack], )

[Divert to 0 or -1, as appropriate.]
define([_dvt], [divert(ifelse(index(condstack, 0), -1, 0, -1))])

[The basic macros.]
define([_ifdef], [define([condstack], ifdef([$1], [1]condstack, [0]condstack))_dvt[]dnl])
define([_if], [define([condstack], ifelse(eval([$1]), 0, [0]condstack, [1]condstack))_dvt[]dnl])
define([defined], [ifdef([$1], 1, 0)])
define([_else], [define([condstack], ifelse(substr(condstack, 0, 1), 1, 0, 1)substr(condstack, 1))_dvt[]dnl])
define([_endif], [define([condstack], substr(condstack, 1))divert(ifelse(index(condstack, 0), -1, 0, -1))[]dnl])

[Output an errno definition.  Usage:  errconst(name, value)
 If value is not a number, don't output anything because this means that the
 particular errno value is undefined on this system.]
[define([errconst], [ifelse(substr(translit($2, 123456789, 000000000), 0, 1), 0, [    ]$1[]substr([                             ], len($1)): constant Error_Code := $2;, [dnl])])]
define([errconst], [ifelse(substr(translit($2, 123456789, 000000000), 0, 1), 0, [    ]$1:substr([                             ], len($1)) constant Error_Code := $2;, [dnl])])

[Process a signal defintion.  Usage:  define_signal(short_name, long_name).
The effect is to define a macro which is then used by the signal_entry
macro.  Note that the number of a signal can be obtained by prepending
and underscore to the short name of the signal.  For example, the m4
variable _SIGINT is defined to be the number of the SIGINT signal.]
define([define_signal], [ifdef([_$1], [define([sig_]_$1, _real_entry([$1], [$2]))])dnl])

[_real_entry is a helper function which creates the text of an entry in
 the signal name table.  The arguments are the short and long name of the
 signal.]
define([_real_entry], [_name_entry([new string'("$1")], new string'(upper_case("$2")))])

[_name_entry is another helper function.  It actually generates the
record aggregate.]
define([_name_entry], [([$1],substr([                      ], len([$1])) [$2])])

[Create the entries in the Signal_Name array.  Usage:  generate_signal_names(1)
 If we know about a signal, define_signal will have defined a macro
 consisting of "sig_" followed by the signal number, and we just output
 that value.  Otherwise, we name the signal "SIGNAL_n", where "n" is the
 signal number.  The argument to this function is the number of the first
 signal.]
define([generate_signal_names], [ifdef([sig_]$1, sig_$1, [_name_entry(null, [new string'("SIGNAL_$1")])])ifelse($1, eval(_NSIG - 1), [], [,
    generate_signal_names(eval($1 + 1))])])

[Convert to upper case.]
define([upper_case], [translit([$1], abcdefghijklmnopqrstuvwxyz, ABCDEFGHIJKLMNOPQRSTUVWXYZ)])

include(cdefs.m4)
include(cdecls.m4)

divert(0)dnl
