--------------------------------------------------------------------------
--  Forest library, version 1.4beta					--
--  Copyright (C) 1995 by Kenneth Almquist				--
--									--
--  You may redistribute or modify this software under the terms	--
--  given in the License for the Forest Library, which appears in	--
--  the file named LICENSE.						--
--------------------------------------------------------------------------

with POSIX,
     POSIX_IO;
package POSIX_Configurable_File_Limits is

    -- link limits

    function Link_Is_Limited(Pathname:  POSIX.Pathname)
    	return Boolean;
    function Link_Is_Limited(File:  POSIX_IO.File_Descriptor)
    	return Boolean;

    function Link_Limit(Pathname:  POSIX.Pathname)
    	return POSIX.Link_Limit_Maxima;
    function Link_Limit(File:  POSIX_IO.File_Descriptor)
    	return POSIX.Link_Limit_Maxima;

    -- input line limits

    function Input_Line_Is_Limited(Pathname:  POSIX.Pathname)
    	return Boolean;
    function Input_Line_Is_Limited(File:  POSIX_IO.File_Descriptor)
    	return Boolean;

    function Input_Line_Limit(Pathname:  POSIX.Pathname)
    	return POSIX.Input_Line_Limit_Maxima;
    function Input_Line_Limit(File:  POSIX_IO.File_Descriptor)
    	return POSIX.Input_Line_Limit_Maxima;

    -- input queue limits

    function Input_Queue_Is_Limited(Pathname:  POSIX.Pathname)
    	return Boolean;
    function Input_Queue_Is_Limited(File:  POSIX_IO.File_Descriptor)
    	return Boolean;

    function Input_Queue_Limit(Pathname:  POSIX.Pathname)
    	return POSIX.Input_Queue_Limit_Maxima;
    function Input_Queue_Limit(File:  POSIX_IO.File_Descriptor)
    	return POSIX.Input_Queue_Limit_Maxima;

    -- filename and pathname limits

    function Filename_Is_Limited(Pathname:  POSIX.Pathname)
    	return Boolean;
    function Filename_Is_Limited(File:  POSIX_IO.File_Descriptor)
    	return Boolean;

    function Filename_Limit(Pathname:  POSIX.Pathname)
    	return POSIX.Filename_Limit_Maxima;
    function Filename_Limit(File:  POSIX_IO.File_Descriptor)
    	return POSIX.Filename_Limit_Maxima;

    function Pathname_Is_Limited(Pathname:  POSIX.Pathname)
    	return Boolean;
    function Pathname_Is_Limited(File:  POSIX_IO.File_Descriptor)
    	return Boolean;

    function Pathname_Limit(Pathname:  POSIX.Pathname)
    	return POSIX.Pathname_Limit_Maxima;
    function Pathname_Limit(File:  POSIX_IO.File_Descriptor)
    	return POSIX.Pathname_Limit_Maxima;

    -- pipe length limits

    function Pipe_Length_Is_Limited(Pathname:  POSIX.Pathname)
    	return Boolean;
    function Pipe_Length_Is_Limited(File:  POSIX_IO.File_Descriptor)
    	return Boolean;

    function Pipe_Length_Limit(Pathname:  POSIX.Pathname)
    	return POSIX.Pipe_Limit_Maxima;
    function Pipe_Length_Limit(File:  POSIX_IO.File_Descriptor)
    	return POSIX.Pipe_Limit_Maxima;

    -- change owner restriction

    function Change_Owner_Is_Restricted(Pathname:  POSIX.Pathname)
    	return POSIX.Change_Owner_Restriction;
    function Change_Owner_Is_Restricted(File:  POSIX_IO.File_Descriptor)
    	return POSIX.Change_Owner_Restriction;

    -- file name truncation

    function Filename_Is_Truncated(Pathname:  POSIX.Pathname)
    	return POSIX.Filename_Truncation;
    function Filename_Is_Truncated(File:  POSIX_IO.File_Descriptor)
    	return POSIX.Filename_Truncation;

end POSIX_Configurable_File_Limits;

