--------------------------------------------------------------------------
--  Forest library, version 1.4beta					--
--  Copyright (C) 1995 by Kenneth Almquist				--
--									--
--  You may redistribute or modify this software under the terms	--
--  given in the License for the Forest Library, which appears in	--
--  the file named LICENSE.						--
--------------------------------------------------------------------------

-- This package defines functions returning various system limits.

with POSIX;
package POSIX_Configurable_System_Limits is

    type POSIX_Version is new Integer;

    function Argument_List_Maximum return POSIX.Argument_List_Maxima;
	-- Returns the maximum 

    function Child_Processes_Maximum return POSIX.Child_Processes_Maxima;

    function Groups_Maximum return POSIX.Groups_Maxima;

    function Open_Files_Maximum return POSIX.Open_Files_Maxima;

    function Job_Control_Supported return POSIX.Job_Control_Support;

    function Saved_IDs_Supported return POSIX.Saved_IDs_Support;

    function Stream_Maximum return POSIX.Stream_Maxima;

    function Time_Zone_String_Maximum return POSIX.Time_Zone_String_Maxima;

    function System_POSIX_Version return POSIX_Version;

    function System_POSIX_Ada_Version return POSIX_Version;

end POSIX_Configurable_System_Limits;
