--------------------------------------------------------------------------
--  Forest library, version 1.4beta					--
--  Copyright (C) 1995 by Kenneth Almquist				--
--									--
--  You may redistribute or modify this software under the terms	--
--  given in the License for the Forest Library, which appears in	--
--  the file named LICENSE.						--
--------------------------------------------------------------------------

with POSIX_Private_2; use POSIX_Private_2;
package body POSIX_Group_Database.More is

use POSIX;

-- generic
--     with procedure Action(Member:  POSIX.POSIX_String;
--			     Quit:    in out Boolean);
procedure For_Every_Group_Member(DB_Item: Group_Database_Item) is
    Quit: Boolean := false;
    Pos: Positive := 1;
begin
    if not DB_Item.Valid then
	Raise_POSIX_Error("Unintialized Group_ID_List", Invalid_Argument);
    end if;
    for I in Item_Index'first .. DB_Item.Users.Num_Items loop
	declare
	    Length: constant User_Name_Length := DB_Item.Users.User_Length(I);
	    Name: POSIX_String(1 .. Length)
			:= DB_Item.Users.Space(Pos .. Pos + Length - 1);
	begin
	    Action(Name, Quit);
	    Pos := Pos + Length;
	end;
	exit when Quit;
    end loop;
end For_Every_Group_Member;

end POSIX_Group_Database.More;
