--------------------------------------------------------------------------
--  Forest library, version 1.4beta					--
--  Copyright (C) 1995 by Kenneth Almquist				--
--									--
--  You may redistribute or modify this software under the terms	--
--  given in the License for the Forest Library, which appears in	--
--  the file named LICENSE.						--
--------------------------------------------------------------------------

package POSIX_Group_Database.More is

    generic
        with procedure Action
                     (Member:  POSIX.POSIX_String;
		      Quit:    in out Boolean);
    procedure For_Every_Group_Member(DB_Item: Group_Database_Item);
	-- exceptions:  none except for those raised by Action.
	-- Calls Action for each member of the group.
	-- By convention, each user has an initial (or primary)
	-- group, which is listed in the User Database.  When a
	-- user appears groups other than his/her primary group,
	-- the user name appears in the member list of these
	-- other groups.  However, this convention is not mandated
	-- by POSIX.  In particular, POSIX does not require the
	-- entries in the member list to be user names.

end POSIX_Group_Database.More;
