/****************************************************************************/
/*                                                                          */
/*                         GNAT COMPILER COMPONENTS                         */
/*                                                                          */
/*                              A - A R G V                                 */
/*                                                                          */
/*                          C Implementation File                           */
/*                                                                          */
/*                            $Revision: 1.6 $                              */
/*                                                                          */
/*    Copyright (C) 1992, 1993, 1994, 1995 Free Software Foundation, Inc.   */
/*                                                                          */
/* GNAT is free software;  you can  redistribute it  and/or modify it under */
/* terms of the  GNU General Public License as published  by the Free Soft- */
/* ware  Foundation;  either version 2,  or (at your option) any later ver- */
/* sion.  GNAT is distributed in the hope that it will be useful, but WITH- */
/* OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY */
/* or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License */
/* for  more details.  You should have  received  a copy of the GNU General */
/* Public License  distributed with GNAT;  see file COPYING.  If not, write */
/* to  the Free Software Foundation,  59 Temple Place - Suite 330,  Boston, */
/* MA 02111-1307, USA.                                                      */
/*                                                                          */
/* As a  special  exception,  if you  link  this file  with other  files to */
/* produce an executable,  this file does not by itself cause the resulting */
/* executable to be covered by the GNU General Public License. This except- */
/* ion does not  however invalidate  any other reasons  why the  executable */
/* file might be covered by the  GNU Public License.                        */
/*                                                                          */
/* GNAT was originally developed  by the GNAT team at  New York University. */
/* It is now maintained by Ada Core Technologies Inc (http://www.gnat.com). */
/*                                                                          */
/****************************************************************************/

/* Routines for accessing command line arguments from both the runtime
   library and from the compiler itself. In the former case, gnat_argc
   and gnat_argv are the original argc and argv values as stored by the
   binder generated main program, and these routines are accessed from
   the Ada.Command_Line package. In the compiler case, gnat_argc and
   gnat_argv are the values as modified by toplev, and these routines
   are accessed from the Osint package. */

#include <string.h>

/* argc and argv of the main program are saved under gnat_argc and gnat_argv */
int gnat_argc = 0;
char **gnat_argv = (char **) 0;

/* ???old names kept for bootstrap problem issues (to be remove after 1.84) */
int static_argc;
char **static_argv;

int arg_count () {

  /* ??? next line to be removed after 1.84 */
  if (gnat_argv == 0) { gnat_argv = static_argv; gnat_argc = static_argc;}

  return gnat_argc;
}
char * *gnat_argval () {

  /* ??? next line to be removed after 1.84 */
  if (gnat_argv == 0) { gnat_argv = static_argv; gnat_argc = static_argc;}

 return  gnat_argv;
}

int len_arg (arg_num)
   int arg_num;
{
  /* ??? next line to be removed after 1.84 */
  if (gnat_argv == 0) { gnat_argv = static_argv; gnat_argc = static_argc;}

  return strlen(gnat_argv[arg_num]);
}

int fill_arg (a, i)
   char * a;
   int i;
{
  /* ??? next line to be removed after 1.84 */
  if (gnat_argv == 0) { gnat_argv = static_argv; gnat_argc = static_argc;}

  strncpy (a, gnat_argv[i], strlen(gnat_argv[i]));
}
