-- OBJECTIVE: 
--      Check that the specification of the package Interfaces.FORTRAN
--      are available for use.
--
-- TEST DESCRIPTION:
--      This test verifies that the parameter is passed in out and in_out
-- to FORTRAN  subprogram correctly 
--      
--
--
-- CHANGE HISTORY:
--      19 SEP 85   Wasu    
--
--
with Ada.Text_IO;	
with Interfaces.FORTRAN; 
use Interfaces.FORTRAN;

procedure CXBSH is

     use Ada.Text_IO;

     procedure SHF_INC ( I: in     Fortran_Character;
                        J: out     Fortran_Character;
                        K: in  out Fortran_Character);
     pragma Import (Fortran, SHF_INC,"shfinc_");

     ATST : String(1..6);                
     TST_I_I, TST_O_I, TST_IO_I: Fortran_Character(1..6);
begin
	 -- Ada need to usr function To_Fortran 
	 -- to transform ada string to fortran string

	 ATST := "TEST11";
         TST_I_I  := To_Fortran( ATST );
         ATST := "TEST22";
         TST_O_I  := To_Fortran( ATST );
         ATST := "TEST33";
         TST_IO_I := To_Fortran( ATST );

	 PUT_LINE("String passing:");
         PUT_LINE("mode: in out in/out");
         PUT_LINE ("Ada send:");	 
         PUT ( To_Ada(TST_I_I) );
         PUT ( To_Ada(TST_O_I) );
         PUT ( To_Ada(TST_IO_I) );
         New_Line;
	 SHF_INC ( TST_I_I, TST_O_I, TST_IO_I );         
         PUT_LINE("Ada recieve:");         
         PUT ( To_Ada(TST_I_I) );
         PUT ( To_Ada(TST_O_I) );
         PUT ( To_Ada(TST_IO_I) );
         New_Line;

end CXBSH;

