with Ada.Text_IO;
use  Ada.Text_IO;
with Interfaces.Fortran;
use  Interfaces.Fortran;
with labase;
use  labase;
with labaseio;
use  labaseio;
with ladrv;
use  ladrv;

Procedure tssyev is

	use labaseio.Integer_IO;
	use labaseio.Real_IO;

	N	 : Fortran_Integer := 3;
	A, X	 : Fortran_Real_Matrix ( 1..N, 1..N);
	W	 : Fortran_Real_Vector ( 1..N );
	LWORK	 : Fortran_Integer := 3 * N - 1 ;
	WORK	 : Fortran_Real_Vector ( 1..LWORK );
	INFO	 : Fortran_Integer;

	ERR, TMP : Real := 0.0;

begin

        -- A is symmetric matrix
        A := (( 2.0,  1.0, -2.0),
              ( 1.0,  2.0, -1.0),
              (-2.0, -1.0,  6.0));

	X := A;

	SSYEV (
	JOBZ	 => 'V',
	UPLO	 => 'U',
	N	 => N,
	A	 => A,
	LDA	 => N,
	W	 => W,
	WORK	 => WORK,
	LWORK	 => LWORK,
	INFO	 => INFO);

	-- Test if error
	if (INFO /= 0) then
	   Put ("ERROR ");
	   Put ( INFO );
	   New_line;
	end if;

	-- Verify routine
        ERR := 0.0;

        for I in W'Range(1) loop

          for J in X'Range(1) loop
            TMP := 0.0;

            for K in X'Range(2) loop
                TMP := TMP + ( X(J,K) * A(K,I) ) ;
            end loop;

            TMP := TMP - ( W(I) * A(J,I) );
            -- PUT (TMP);
            -- new_line;
            ERR := ERR + abs( TMP );
          end loop;
          
        end loop;
                

	PUT ( "Abs Error:");
	PUT ( ERR );
	New_line;

end tssyev;
