with Ada.Text_IO;
use  Ada.Text_IO;
with Interfaces.Fortran;
use  Interfaces.Fortran;
with labase;
use  labase;
with labaseio;
use  labaseio;
with ladrv;
use  ladrv;

Procedure tchesv is

	use labaseio.Integer_IO;
	use labaseio.Real_IO;

	N	 : Fortran_Integer := 3;
	A,X	 : Fortran_Complex_Matrix ( 1..N, 1..N);
	IPIV	 : Fortran_Integer_Vector ( 1..N );
	B,Y	 : Fortran_Complex_Matrix ( 1..N, 1..N);
	LDB	 : Fortran_Integer;
	LWORK	 : Fortran_Integer := N;
	WORK	 : Fortran_Complex_Vector ( 1..LWORK );
	INFO	 : Fortran_Integer;

        Z        : Fortran_Complex_Matrix ( 1..N, 1..N);
	ERR : Real := 0.0;

begin

	-- A is Hermitian matrix
        A := (( ( 3.0, 0.0), ( 1.0,-2.0), ( 4.0, 7.0)),
              ( ( 1.0,+2.0), (-4.0, 0.0), ( 0.0,-2.0)),
              ( ( 4.0,-7.0), ( 0.0, 2.0), ( 2.0, 0.0)));

        B := (( (9.0, 3.0), ( 9.0, 7.0), ( 16.0, 11.0)),
              ( (2.0, 7.0), (-2.0,-1.0), ( -4.0,  4.0)),
              ( (5.0,-2.0), ( 8.0, 2.0), (-11.0, -3.0)));

	X := A;
	Y := B;

	CHESV (
	UPLO	 => 'U',
	N	 => N,
	NRHS	 => N,
	A	 => A,
	LDA	 => N,
	IPIV	 => IPIV,
	B	 => B,
	LDB	 => N,
	WORK	 => WORK,
	LWORK	 => LWORK,
	INFO	 => INFO);

	-- Test if error
	if (INFO /= 0) then
	   Put ("ERROR ");
	   Put ( INFO );
	   New_line;
	end if;

	-- Verify routine
        for I in Z'Range (1) loop
           for J in Z'Range(2) loop
              Z(I,J) := (0.0,0.0);
              for K in A'Range(2) loop
                 Z(I,J) := Z(I,J) + ( X(I,K) * B(K,J));
              end loop;
              ERR := ERR + abs (Z(I,J) - Y(I,J));
           end loop;
        end loop;

	PUT ( "Abs Error:");
	PUT ( ERR );
	New_line;

end tchesv;
