with Ada.Text_IO; use Ada.Text_IO;
with Interfaces.Fortran; 
use Interfaces.Fortran;
with labase; use labase;
with labaseio; use labaseio;
with ladrv; use ladrv;

procedure tdpbsv is 

    use Labaseio.Double_Precision_IO;

	N: Fortran_Integer := 3;
	A: Fortran_Double_Precision_Matrix ( 1..N, 1..N );
	AB: Fortran_Double_Precision_Matrix ( 1..3, 1..N );
	B,Y: Fortran_Double_Precision_Matrix ( 1..N, 1..N );
	Z: Fortran_Double_Precision_Matrix ( 1..N, 1..N );
	
	ERR: Double_Precision := 0.0;
	IPIV : Fortran_Integer_Vector ( 1..N ); 
	INFO : Fortran_Integer;
begin 
   
        -- A is symmetric positive definite band metric

	A := (( 2.0, -1.0,  2.0),
              (-1.0,  2.0, -1.0),
              ( 2.0, -1.0,  6.0));

	-- AB is A in band triangular storage scheme
	-- ku = 2

	AB := ((0.0,  0.0,  2.0),
               (0.0, -1.0, -1.0),
               (2.0,  2.0,  6.0));
	

	B := (( 9.0,  9.0, 16.0),
	      ( 7.0, -2.0,  4.0),
	      ( 2.0,  8.0,-11.0));

	Y := B;

	DPBSV (
	UPLO	 => 'U',
	N	 => N,
	KD	 => 2,
	NRHS	 => N,
	AB	 => AB,
	LDAB	 => 3,
	B	 => B,
	LDB	 => N,
	INFO	 => INFO );


	if (INFO /= 0) then 
	   Put_line ("ERROR");
	end if;


        for I in Z'Range (1) loop
	   for J in Z'Range(2) loop
	      Z(I,J) := 0.0;
	      for K in A'Range(2) loop
		 Z(I,J) := Z(I,J) + ( A(I,K) * B(K,J));
	      end loop;
	      ERR := ERR + abs (Z(I,J) - Y(I,J));
	   end loop;
	end loop;

        -- PUT (Y);
	-- PUT (Z);
	PUT ( "Abs Error:");
	PUT ( ERR );
	New_line;

end tdpbsv;



