with Ada.Text_IO; 
use  Ada.Text_IO;
with Interfaces.Fortran; 
use  Interfaces.Fortran;
with labase; 
use  labase;
with labaseio; 
use  labaseio;
with ladrv; 
use  ladrv;

procedure tsppsv is 

    	use Labaseio.Real_IO;
	use labaseio.Integer_IO;

	N: Fortran_Integer := 3;
	A: Fortran_Real_Matrix ( 1..N, 1..N );

	AP : Fortran_Real_Vector ( 1..6 );

	B,Y: Fortran_Real_Matrix ( 1..N, 1..N );
	Z: Fortran_Real_Matrix ( 1..N, 1..N );

	ERR: Real := 0.0;
	INFO : Fortran_Integer;
begin 
   
        -- A is symmetric  metric

	A := (( 2.0, -1.0,  1.0),
              (-1.0,  1.0, -2.0),
              ( 1.0, -2.0,  6.0));

	-- AP is packed  arrays

        AP := ( A(1,1), A(1,2), A(2,2), A(1,3), A(2,3), A(3,3));
	
	B := (( 9.0,  9.0,  16.0),
	      ( 7.0, -2.0,   4.0),
	      ( 2.0,  8.0, -11.0));

	Y := B;

	SPPSV (
        UPLO     => 'U',
        N        => N,
        NRHS     => N,
        AP       => AP,
        B        => B,
        LDB      => N,
        INFO     => INFO );

	if (INFO /= 0) then 
	   Put ("ERROR ");
	   Put ( INFO );
	   New_line;
	end if;


        for I in Z'Range (1) loop
	   for J in Z'Range(2) loop
	      Z(I,J) := 0.0;
	      for K in A'Range(2) loop
		 Z(I,J) := Z(I,J) + ( A(I,K) * B(K,J));
	      end loop;
	      ERR := ERR + abs (Z(I,J) - Y(I,J));
	   end loop;
	end loop;

        -- PUT (Y);
        -- PUT (Z);
	PUT ( "Abs Error:");
	PUT ( ERR );
	New_line;

end tsppsv;



