------------------------------------------------------------------------------
--                                                                          --
--                            PM Test Program                               --
--                                                                          --
--                                Menu                                      --
--                                                                          --
--   Vers .1           A Simple Menu testing program                        --
--   Vers .2           Testing of the Menu binding	                    --
--   Vers .3           Convert program to use changed menu calls            --
--         .31         Minor changes for version 2.03 of GNAT               --
--                                                                          --
--                            $Revision: .31 $                              --
--                                                                          --
--   Copyright (c) 1994,1995 Dimensional Media Systems, All Rights Reserved --
--                                                                          --
--   The PM bindings are free software; you can redistribute them and/or    --
--   modify them under terms of the GNU General Public License as published --
--   by the Free Software Foundation; either version 2, or (at your         --
--   option) any later version.  The PM bindings are distributed in the     --
--   hope that they will be useful, but WITH OUT ANY WARRANTY; without even --
--   the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR    --
--   PURPOSE.  See the GNU General Public License for more details.  You    --
--   should have received a copy of the GNU General Public License          --
--   distributed with The PM bindings; see file COPYING.  If not, write to  --
--   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
--   For more information about these PM bindings and their usage with GNAT --
--   you can contact Bill Yow at                                            --
--                                                                          --  
--      Dimensional Media Systems (DMS)                                     --
--      1522 Festival Dr.                                                   --
--      Houston TX, 77062                                                   --
--      Phone - (713) 486-6116                                              --
--      Email - Byow@mci.com                                                --
--                                                                          --
------------------------------------------------------------------------------

with Win;
with GPI;
with Text_Io;
with Pm_Types;
with Dos;

procedure Menu is

  Version        : constant String := "0.31";

  Hab            : Win.Anchor_Block_Handle_Type;
  Queue          : Win.Queue_Handle_Type; 

  Queue_Message  : Win.Queue_Message_Pointer_Type;

  Button_Pressed : Win.MB_Response_Type;

  Frame_Cf       : Win.Frame_Control_Flags_Type;
  New_Win        : Win.Handle_Pointer_Type;
  Pop_Up_Menu    : Win.Menu_Type := Win.Null_Menu;
  Frame_Win      : Win.Handle_Type; 

  Successful     : Boolean;
  Window_Style   : Win.Class_Styles_Type := (others => False);

  Key_Info       : Win.Key_Press_Info_Type;

  Point          : Win.Point_Type := (10, 350);
  Added          : Boolean := False;

  Id_Window      : constant Win.Id_Type         := 200;
  Id_Pop_Up      : constant Win.Id_Type         := 201;

  Id_Draw        : constant Win.Command_Id_Type := 300;

  Id_Graphics    : constant Win.Command_Id_Type := 299;
  Id_Lines       : constant Win.Command_Id_Type := 301;
  Id_Arcs        : constant Win.Command_Id_Type := 302;
  Id_Rectangles  : constant Win.Command_Id_Type := 303;

  Id_State             : constant Win.Command_Id_Type := 310;
  Id_State_Lines       : constant Win.Command_Id_Type := 311;
  Id_State_Arcs        : constant Win.Command_Id_Type := 312;
  Id_State_Rectangles  : constant Win.Command_Id_Type := 313;

  Id_Check             : constant Win.Command_Id_Type := 320;
  Id_Check_Lines       : constant Win.Command_Id_Type := 321;
  Id_Check_Arcs        : constant Win.Command_Id_Type := 322;
  Id_Check_Rectangles  : constant Win.Command_Id_Type := 323;

  Id_Status	 : constant Win.Command_Id_Type := 305;
  Id_Clear       : constant Win.Command_Id_Type := 304;

  Id_Added       : constant Win.Command_Id_Type := 310;

  Obj_Buf    : Dos.Object_Buffer_Type (1 .. 100);
  Empty_Str  : String (1 .. 1) := " ";
  Results    : Dos.Result_Codes_Type;
  Run_Pgm    : String (1 .. 8) := "menu.exe";  
  Dos_Result : Dos.Api_Return_Code;
  Launch     : Boolean := False;

  ------------------------------------------------------------------

   procedure Draw_Arcs (Window : Win.Handle_Type) is
      Ps           : Win.Ps_Type; 
     begin

       Ps := Win.Get_Ps (Window);

       GPI.Set_Background_Mix (Ps, GPI.Bm_Overpaint);
       GPI.Set_Background_Color (Ps, Win.Clr_Background);
       GPI.Set_Color (Ps, Win.Clr_Blue);
       GPI.Char_String_At (
                              Ps    => Ps,
                              Point => (400, 350),
                              Text  => "Arcs");
          
            --A Circle
       GPI.Set_Color (Ps, Win.Clr_White);
       Gpi.Full_Arc (
                 Ps            => Ps,
                 Center        => (420, 75),
                 Arc_Params    => (1, 1, 0, 0), 
                 Outline_Style => Gpi.Dro_Outline,
                 Multiplier    => 50);

            --A Width Ellipse
       GPI.Set_Color (Ps, Win.Clr_Brown);
       Gpi.Full_Arc (
                 Ps            => Ps,
                 Center        => (420, 200),
                 Arc_Params    => (1, 2, 0, 0), 
                 Outline_Style => Gpi.Dro_Fill,
                 Multiplier    => 25);

            --A Tall Ellipse
       GPI.Set_Color (Ps, Win.Clr_Yellow);
       Gpi.Full_Arc (
                 Ps            => Ps,
                 Center        => (420, 305),
                 Arc_Params    => (2, 1, 0, 0), 
                 Outline_Style => Gpi.Dro_Outline_Fill,
                 Multiplier    => 25);

       Win.Release_Ps (Ps);
    end Draw_Arcs;

  ------------------------------------------------------------------

    procedure Draw_Rectangles (Window : in Win.Handle_Type) is
        Ps           : Win.Ps_Type; 
      begin

        Ps := Win.Get_Ps (Window);

        GPI.Set_Background_Mix (Ps, GPI.Bm_Overpaint);
        GPI.Set_Background_Color (Ps, Win.Clr_Background);
        GPI.Set_Color (Ps, Win.Clr_Blue);
        GPI.Char_String_At (
                              Ps    => Ps,
                              Point => (200, 350),
                              Text  => "Rectangles");
          
        GPI.Set_Color (Ps, Win.Clr_Red);
        Gpi.Box (Ps            => Ps,
                    Start_Corner    => (200, 50),
                    End_Corner      => (300, 125),
                    Outline_Style   => Gpi.Dro_Fill,
                    Horz_Rounding   => 0,
                    Vert_Rounding   => 0);

        GPI.Set_Color (Ps, Win.Clr_Blue);
        Gpi.Box (Ps            => Ps,
                    Start_Corner  => (200, 175),
                    End_Corner    => (300, 250),
                    Outline_Style => Gpi.Dro_Outline,
                    Horz_Rounding => 10,
                    Vert_Rounding => 10);
                    
        GPI.Set_Color (Ps, Win.Clr_Dark_Green);
        Gpi.Box (Ps            => Ps,
                    Start_Corner  => (200, 265),
                    End_Corner    => (300, 340),
                    Outline_Style => Gpi.Dro_Outline_Fill,
                    Horz_Rounding => 30,
                    Vert_Rounding => 30);

        Win.Release_Ps (Ps);

   end Draw_Rectangles;

  -------------------------------------------------------

   procedure Draw_Lines (Window : in Win.Handle_Type) is
        Ps           : Win.Ps_Type; 

       use Win;
     begin

       Ps := Win.Get_Ps (Window);

       GPI.Set_Background_Mix (Ps, GPI.Bm_Overpaint);
       GPI.Set_Background_Color (Ps, Win.Clr_Background);
       GPI.Set_Color (Ps, Win.Clr_Blue);
       GPI.Char_String_At (
                           Ps    => Ps,
                           Point => (60, 350),
                           Text  => "Lines");
          
       GPI.Set_Color (Ps, Win.Clr_Pink);

       for I in 1 .. 35 loop
          GPI.Line (Ps          => Ps,
                    Start_Point => (50, 50),
                    End_Point   => (X => 150 - (Win.Pixel_Type (I) * 3), 
                                    Y => 70 + (Win.Pixel_Type (I) * 8)));
       end loop;

       Win.Release_Ps (Ps);

   end Draw_Lines;

  ------------------------------------------------------------------

    procedure Check_Menu_Item (Item_Id    : in Win.Command_ID_Type;
                               By_Pointer : in Boolean) is
 
      Menu    : Win.Menu_Type := Win.Null_Menu;
      Result  : Boolean;

    begin

      Menu    := Win.Menu_Is (Frame_Win);

      Result  := Win.Check_Menu_Item (
                       Menu    => Menu,
                       Item_Id => Item_Id,
                       Check   => By_Pointer);

      Result  := Win.Enable_Menu_Item (
                       Menu     => Menu,
                       Item_Id  => Item_Id,
                       Enable   => By_Pointer);

    end Check_Menu_Item;

  ------------------------------------------------------------------

    procedure Erase_Screen (Window : in Win.Handle_Type) is 
        Ps : Win.Ps_Type; 
     begin

       Ps := Win.Get_Ps (Window);
       Gpi.Erase (Ps);
       Win.Release_Ps (Ps);

       Check_Menu_Item (Id_Lines, False);
       Check_Menu_Item (Id_Arcs, False);
       Check_Menu_Item (Id_Rectangles, False);

     end Erase_Screen;

  ------------------------------------------------------------------

    procedure Toggle_Check (For_Id : Win.Command_Id_Type) is
 
      Menu    : Win.Menu_Type;
      Result  : Boolean;

    begin

      Menu   := Win.Menu_Is (Frame_Win);

      Result := Win.Check_Menu_Item (
                          Menu => Menu,
                          Item_Id => For_Id,
                          Check   => not (       
                                     Win.Is_Menu_Item_Checked (Menu    => Menu,
                                                               Item_Id => For_Id)));
    end Toggle_Check;

  ------------------------------------------------------------------

    procedure Toggle_State (For_Id : Win.Command_Id_Type) is
 
      Menu    : Win.Menu_Type := Win.Null_Menu;
      Result  : Boolean;

    begin

      Menu   := Win.Menu_Is (Frame_Win);

      Result := Win.Enable_Menu_Item (
                          Menu    => Menu,
                          Item_Id => For_Id,
                          Enable  => not (       
                                     Win.Is_Menu_Item_Enabled (Menu    => Menu,
                                                               Item_Id => For_Id)));
    end Toggle_State;

  ------------------------------------------------------------------

   procedure Write_Message (Window  : in Win.Handle_Type;
                            Message : in String) is 

    Ps           : Win.Ps_Type; 

    Options      : Win.Pop_Up_Options_Type;

    use Win;
   begin

           Ps := Win.Get_Ps (Window);
           GPI.Set_Background_Mix (Ps, GPI.Bm_Overpaint);
           GPI.Set_Background_Color (Ps, Win.Clr_Pale_Gray);
           GPI.Set_Color (Ps, Win.Clr_Blue);
           GPI.Char_String_At (
                              Ps    => Ps,
                              Point => (400, 10),
                              Text  => Message);
           Win.Release_Ps (Ps);

   end Write_Message;

  ------------------------------------------------------------------

   procedure Process_Menu (Command_Id : in Win.Command_Id_Type;
                           For_Window : in Win.Handle_Type;
                           By_Pointer : in Boolean) is

       Menu   : Win.Menu_Type := Win.Null_Menu;
       Result : Boolean;
     begin


       case Command_Id is

         when Id_Lines       => Draw_Lines (For_Window);
         when Id_Arcs        => Draw_Arcs  (For_Window);
         when Id_Rectangles  => Draw_Rectangles (For_Window);

         when Id_Check_Lines      => Toggle_Check (For_Id => Id_Lines);
         when Id_Check_Arcs       => Toggle_Check (For_Id => Id_Arcs);
         when Id_Check_Rectangles => Toggle_Check (For_Id => Id_Rectangles);

         when Id_State_Lines      => Toggle_State (For_Id => Id_Lines);
         when Id_State_Arcs       => Toggle_State (For_Id => Id_Arcs);
         when Id_State_Rectangles => Toggle_State (For_Id => Id_Rectangles);
              
         when Id_Status     => 

           Menu := Win.Menu_Is (Frame_Win);

           Write_Message (Window  => For_Window,
                          Message => "Line is Enabled " &                                     
                                        Boolean'Image (
                                           Win.Is_Menu_Item_Enabled (
                                                 Menu    => Menu,
                                                 Item_Id => Id_Lines)));

         when Id_Clear      => Erase_Screen (For_Window);

         when others        => null;
       end case;

     end Process_Menu;

  ------------------------------------------------------------------

  function Win_Test_Handler (Window  : Win.Handle_Type;
                             Message : Win.Message_Type;
                             MP1     : Win.Parameter_Type;
                             MP2     : Win.Parameter_Type) 
                                           return Pm_Types.U_Long is
    Result       : Boolean;
    Ps           : Win.Ps_Type; 

    Str          : String (1 .. 1);

    Gpi_Results  : Gpi.Status_Type;
    Command_Info : Win.Command_Info_Type;

    Point        : Win.Point_Type;
    Options      : Win.Pop_Up_Options_Type;

    use Win;
   begin

     case Message is

      when Win.Wm_Button_1_Down => 
           
           Ps := Win.Get_Ps (Window);
           GPI.Set_Background_Mix (Ps, GPI.Bm_Overpaint);
           GPI.Set_Background_Color (Ps, Win.Clr_Pale_Gray);
           GPI.Set_Color (Ps, Win.Clr_Blue);
           GPI.Char_String_At (
                              Ps    => Ps,
                              Point => Win.Pointer_Is (MP1),
                              Text  => "Menu Test Program Version " & Version);
           Win.Release_Ps (Ps);

           return 1;

      when Win.Wm_Button_2_Down => 

            if Win.Is_Null (Pop_Up_Menu) then
               Pop_Up_Menu := Win.Load_Menu (
                               Owner_Window => Window,
                               Resource     => Null,
                               Menu_Id      => ID_Pop_Up); 
            end if;

            if Win.Is_Null (Pop_Up_Menu) then
               Text_io.Put_Line ("Pop menu does not exist");
            else

               Options := (others => False);
               Options (Win.Pu_Position_On_Item) := True;
               Options (Win.Pu_Mouse_Button_1)   := True;
               Options (Win.Pu_Keyboard)         := True;

               Point   := Win.Pointer_Is (MP1);

               Result := Win.Pop_Up_Menu (
                     Window       => Window,
                     Frame_Window => Frame_Win,
                     Menu         => Pop_Up_Menu,
                     X            => Point.X,
                     Y            => Point.Y,
                     Item_Id      => Id_Arcs,
                     Options      => Options);

               if Result then 
                  null;
                  --Text_Io.Put_Line ("It should have worked");
               else
                  Text_Io.Put_Line ("It Failed");
               end if;

            end if;

            return 1;

      when Win.Wm_Char => 
           Key_Info := Win.Key_Info_Is (Mp1, Mp2);

           if (Key_Info.Flags (Win.Kc_Char) and then
               not Key_Info.Flags (Win.Kc_Virtual_Key)) or else
                (Key_Info.Flags (Win.Kc_Virtual_Key) and then
                   Key_Info.Virtual_Key = Win.Vk_Space and then
                    not Key_Info.Flags (Win.Kc_Key_Up)) then

             Str (1) := Character'Val (Integer (Key_Info.Character_Code));

             Ps := Win.Get_Ps (Window);

             GPI.Set_Background_Mix (Ps, GPI.Bm_Overpaint);
             GPI.Set_Background_Color (Ps, Win.Clr_Background);
             GPI.Char_String_At (
                              Ps    => Ps,
                              Point => Point,
                              Text  => Str);
             Win.Release_Ps (Ps);

             Point.X := Point.X + 11;

             if Point.X > 200 then
                Point.X := 10;
                Point.Y := Point.Y - 18;
             end if;

           elsif key_Info.Flags (Win.Kc_Virtual_Key) and then
                 not Key_Info.Flags (Win.Kc_Key_Up) then
             null;
           end if;

           return Win.Default_Window_Procedure (Window, Message, Mp1, Mp2);

      when Win.Wm_Command => 

         Command_Info := Win.Command_Info_Is (Mp1, Mp2);

         case Command_Info.Source is

           when Win.Cmd_Src_Menu =>
             Process_Menu (Command_Info.Id, Window, Command_Info.By_Pointer);

           when Win.Cmd_Src_Accelerator =>
             Process_Menu (Command_Info.Id, Window, Command_Info.By_Pointer);

           when others => null;
         end case;

  
         return 1;

      when Win.Wm_Erase_Background => 
           return 1;

      when Win.Wm_Close =>
        Result := Win.Post_Message (Window, Win.Wm_Quit, 0, 0);

      when others => 
            return Win.Default_Window_Procedure (Window, Message, Mp1, Mp2);
     end case;

     return 0;

   end Win_Test_Handler; 

  ------------------------------------------------------------------

   procedure Show_Error (Message : String) is
     begin
       Button_Pressed := Win.Message_Box (
                        Parent_Window  => Win.Desktop_Window,
                        Request_Owner  => Win.Null_Window,
                        Message        => Message,
                        Title          => " Error ",
                        Help_Id        => 1,
                        Buttons        => Win.MB_Ok,
                        Icons          => Win.Mb_Icon_Hand, 
                        Default_Action => Win.Mb_Default_On_Button_1);
     end Show_Error;

  ------------------------------------------------------------------

   use Pm_Types;

  begin

    New_Win       := new Win.Handle_Type;
    Queue_Message := new Win.Queue_Message_Type;

    Win.Initialize (Win.System_Default, Hab);

    Win.Create_Message_Queue (Hab, Win.System_Default, Queue);    

    Window_Style (Win.Cs_Size_Redraw) := True;

    Win.Register_Class (
                        Anchor_Block    => Hab,
                        Class_Name      => "My_Window_Class",
                        Message_Handler => Win_Test_Handler'access,
                        Class_Style     => Window_Style,
                        Extra_Storage   => 0); 

    Frame_CF := 
       (Win.Fcf_Title_Bar     => True,
        Win.Fcf_System_Menu   => True,
        Win.Fcf_Min_Max       => True,
        Win.Fcf_Sizing_Border => True,
        Win.Fcf_Task_List     => True,
        Win.Fcf_Menu          => True,
        Win.Fcf_Accel_Table   => True,
        others                => False);

    Frame_Win := Win.Create_Standard_Window (
             Parent_Window       => Win.Desktop_Window,
             Window_Styles       => Win.Use_Class_Styles,
             Frame_Control_Flags => Frame_CF,
             Class_Name          => "My_Window_Class",
             Window_Title        => "Menu Test program Version " & Version,
             Class_Style         => Window_Style,
             Resource            => null, 
             Resource_ID         => 200,
             New_Window          => New_Win);

    if Win.Is_Null (Frame_Win) then
       Show_Error ("The window was not created");
    else

       Win.Set_Window_Position (
               Window           => Frame_Win,
               Behind_Window    => Win.Top_Window,
               X                => 20,
               Y                => 20,
               Width            => 600,
               Height           => 430,
               Position_Options => Win.Show_Window_Cnt);

       loop

          exit when not Win.Get_Message 
                         (Hab, Queue_Message, Win.Null_Window, 0, 0);

          Win.Dispatch_Message (Hab, Queue_Message);

       end loop;

    end if;

    Win.Destroy_Message_Queue (Queue);
    Win.Terminate_App (Hab);

  end Menu;
