------------------------------------------------------------------------------
--                                                                          --
--                               PM Bindings                                --
--                                                                          --
--                                Port_IO                                   --
--                                                                          --
--                    Binding to the OS/2 EMX API routines                  -- 
--                                                                          --
--                            $Revision: .17 $                              --
--                                                                          --
--                                                                          --
--     Copyright (c) 1995 Dimensional Media Systems, All Rights Reserved    --
--                                                                          --
--   The OS/2 bindings EMX are free software; you can redistribute them and/or --
--   modify them under terms of the GNU General Public License as published --
--   by the Free Software Foundation; either version 2, or (at your         --
--   option) any later version.  The PM bindings are distributed in the     --
--   hope that they will be useful, but WITH OUT ANY WARRANTY; without even --
--   the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR    --
--   PURPOSE.  See the GNU General Public License for more details.  You    --
--   should have received a copy of the GNU General Public License          --
--   distributed with The PM bindings; see file COPYING.  If not, write to  --
--   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
--   For more information about these PM bindings and their usage with GNAT --
--   you can contact Bill Yow at                                            --
--                                                                          --  
--      Dimensional Media Systems (DMS)                                     --
--      1522 Festival Dr.                                                   --
--      Houston TX, 77062                                                   --
--      Phone - (713) 486-6116                                              --
--      Email - Byow@mci.com                                                --
--                                                                          --
------------------------------------------------------------------------------

with Pm_Types;

package body Port_Io is

  procedure Access_Ports (Port_First : in Pm_Types.U_Long;
                          Port_Last  : in Pm_Types.U_Long) is
   
    function portaccess (First : Pm_Types.U_Long;
                         Last  : Pm_Types.U_Long) 
                              return Pm_Types.Long;

    pragma Import (Convention => C,
                   Entity     => portaccess,
                   Link_Name  => "__portaccess");

    use Pm_Types;     
   begin

     if portaccess (Port_First, Port_Last) = -1 then
       raise Port_Access_Failed;
     end if;

   end Access_Ports;

  --------------------------------------------------

  procedure Out_Port (Port  : in Pm_Types.U_Long;
                      Value : in Pm_Types.U_Byte) is
 
    procedure outp8 (Port  : Pm_Types.U_Long;
                    Value : Pm_Types.U_Long);

    pragma Import (Convention => C,
                   Entity     => outp8,
                   Link_Name  => "__outp8");
  begin
    Outp8 (Port, Pm_Types.U_Long (Value));
  end Out_Port;

  --------------------------------------------------

  function In_Port (Port  : in Pm_Types.U_Long) return Pm_Types.U_Byte is
    function inp8 (Port  : Pm_Types.U_Long) return Pm_Types.U_Long;

    pragma Import (Convention => C,
                   Entity     => inp8,
                   Link_Name  => "__inp8");
  begin
    return Pm_Types.U_Byte (Inp8 (Port));
  end In_Port;

end Port_Io;


