------------------------------------------------------------------------------
--                                                                          --
--                               PM Bindings                                --
--                                                                          --
--                                Port_IO                                   --
--                                                                          --
--                    Binding to the OS/2 EMX API routines                  -- 
--                                                                          --
--                            $Revision: .17 $                              --
--
--   .17
--   
--   Access_Ports
--   In_Port
--   Out_Port
--                                                                          --
--     Copyright (c) 1995 Dimensional Media Systems, All Rights Reserved    --
--                                                                          --
--   The OS/2 bindings EMX are free software; you can redistribute them and/or --
--   modify them under terms of the GNU General Public License as published --
--   by the Free Software Foundation; either version 2, or (at your         --
--   option) any later version.  The PM bindings are distributed in the     --
--   hope that they will be useful, but WITH OUT ANY WARRANTY; without even --
--   the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR    --
--   PURPOSE.  See the GNU General Public License for more details.  You    --
--   should have received a copy of the GNU General Public License          --
--   distributed with The PM bindings; see file COPYING.  If not, write to  --
--   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
--   For more information about these PM bindings and their usage with GNAT --
--   you can contact Bill Yow at                                            --
--                                                                          --  
--      Dimensional Media Systems (DMS)                                     --
--      1522 Festival Dr.                                                   --
--      Houston TX, 77062                                                   --
--      Phone - (713) 486-6116                                              --
--      Email - Byow@mci.com                                                --
--                                                                          --
------------------------------------------------------------------------------

with Pm_Types;

package Port_Io is

  Port_Access_Failed : exception;

  procedure Access_Ports (Port_First : in Pm_Types.U_Long;
                          Port_Last  : in Pm_Types.U_Long);

  procedure Out_Port (Port  : in Pm_Types.U_Long;
                      Value : in Pm_Types.U_Byte);

  function In_Port (Port  : in Pm_Types.U_Long) return Pm_Types.U_Byte;

end Port_Io;
  