------------------------------------------------------------------------------
--                                                                          --
--                               PM Bindings                                --
--                                                                          --
--                                 Slider                                   --
--                                                                          --
--                            $Revision: .1 $                               --
--                                                                          --
--   Copyright (c) 1994,1995 Dimensional Media Systems, All Rights Reserved --
--                                                                          --
--   The PM bindings are free software; you can redistribute them and/or    --
--   modify them under terms of the GNU General Public License as published --
--   by the Free Software Foundation; either version 2, or (at your         --
--   option) any later version.  The PM bindings are distributed in the     --
--   hope that they will be useful, but WITH OUT ANY WARRANTY; without even --
--   the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR    --
--   PURPOSE.  See the GNU General Public License for more details.  You    --
--   should have received a copy of the GNU General Public License          --
--   distributed with The PM bindings; see file COPYING.  If not, write to  --
--   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
--   For more information about these PM bindings and their usage with GNAT --
--   you can contact Bill Yow at                                            --
--                                                                          --  
--      Dimensional Media Systems (DMS)                                     --
--      1522 Festival Dr.                                                   --
--      Houston TX, 77062                                                   --
--      Phone - (713) 486-6116                                              --
--      Email - Byow@mci.com                                                --
--                                                                          --
------------------------------------------------------------------------------

with Win;
with GPI;
with Text_Io;
with Pm_Types;
with Dos;

procedure Slider is

  Version        : constant String := "0.1";
  Title          : constant String := "Slider and Spin control test";

  Hab            : Win.Anchor_Block_Handle_Type;
  Queue          : Win.Queue_Handle_Type; 

  Queue_Message  : Win.Queue_Message_Pointer_Type;

  Button_Pressed : Win.MB_Response_Type;

  Frame_Cf       : Win.Frame_Control_Flags_Type;
  New_Win        : Win.Handle_Pointer_Type;
  Pop_Up_Menu    : Win.Menu_Type := Win.Null_Menu;
  Frame_Win      : Win.Handle_Type; 

  Successful     : Boolean;
  Window_Style   : Win.Class_Styles_Type := (others => False);

  Key_Info       : Win.Key_Press_Info_Type;

  Point          : Win.Point_Type := (10, 350);
  Added          : Boolean := False;

  Spin_Button    : Win.Spin_Button_Type := Win.Null_Spin_Button;

  Slider_Window  : Win.Slider_Type := Win.Null_Slider;

  Id_Window      : constant Win.Id_Type         := 200;
  Id_Pop_Up      : constant Win.Id_Type         := 201;

  Id_Draw        : constant Win.Command_Id_Type := 300;

  Id_Windows     : constant Win.Command_Id_Type := 250;
  Id_New_Window  : constant Win.Command_Id_Type := 260;
  Id_Scroll_Bar  : constant Win.Command_Id_Type := 261;

  ID_Spin_Button        : constant Win.Command_ID_Type := 270;

  ID_Create_Spin_Button : constant Win.Command_ID_Type := 271;
  ID_SB_Current_Value   : constant Win.Command_ID_Type := 272;
  ID_SB_Current_Limits  : constant Win.Command_ID_Type := 273;
  ID_SB_Up_1            : constant Win.Command_ID_Type := 274;
  ID_SB_Up_10           : constant Win.Command_ID_Type := 275;
  ID_SB_Down_1          : constant Win.Command_ID_Type := 276;
  ID_SB_Down_10         : constant Win.Command_ID_Type := 277;

  Id_Graphics    : constant Win.Command_Id_Type := 299;
  Id_Lines       : constant Win.Command_Id_Type := 301;
  Id_Arcs        : constant Win.Command_Id_Type := 302;
  Id_Rectangles  : constant Win.Command_Id_Type := 303;

  Id_State             : constant Win.Command_Id_Type := 310;
  Id_State_Lines       : constant Win.Command_Id_Type := 311;
  Id_State_Arcs        : constant Win.Command_Id_Type := 312;
  Id_State_Rectangles  : constant Win.Command_Id_Type := 313;

  Id_Check             : constant Win.Command_Id_Type := 320;
  Id_Check_Lines       : constant Win.Command_Id_Type := 321;
  Id_Check_Arcs        : constant Win.Command_Id_Type := 322;
  Id_Check_Rectangles  : constant Win.Command_Id_Type := 323;

  Id_Status	 : constant Win.Command_Id_Type := 305;
  Id_Clear       : constant Win.Command_Id_Type := 304;

  Id_Added       : constant Win.Command_Id_Type := 310;

  ID_Slider           : constant Win.Command_Id_Type := 400;
  ID_SD_Create        : constant Win.Command_Id_Type := 401;
  ID_SD_At_Tick       : constant Win.Command_Id_Type := 402;
  ID_SD_To_Tick       : constant Win.Command_Id_Type := 403;
  ID_SD_Tick_0        : constant Win.Command_Id_Type := 404;
  ID_SD_Tick_10       : constant Win.Command_Id_Type := 405;
  ID_SD_Tick_20       : constant Win.Command_Id_Type := 406;
  ID_SD_Tick_30       : constant Win.Command_Id_Type := 407;
  ID_SD_Tick_40       : constant Win.Command_Id_Type := 408;
  ID_SD_Tick_50       : constant Win.Command_Id_Type := 409;
  ID_SD_At_Percent    : constant Win.Command_Id_Type := 410;
  ID_SD_To_Percent    : constant Win.Command_Id_Type := 411;
  ID_SD_0_Percent     : constant Win.Command_Id_Type := 412;
  ID_SD_25_Percent    : constant Win.Command_Id_Type := 413;
  ID_SD_50_Percent    : constant Win.Command_Id_Type := 414;
  ID_SD_75_Percent    : constant Win.Command_Id_Type := 415;
  ID_SD_100_Percent   : constant Win.Command_Id_Type := 416;
  ID_SD_Arm_Size      : constant Win.Command_Id_Type := 417;
  ID_SD_Set_Arm_Size  : constant Win.Command_Id_Type := 418;
  ID_SD_Add_Arm_L     : constant Win.Command_Id_Type := 419;
  ID_SD_Sub_Arm_L     : constant Win.Command_Id_Type := 420;
  ID_SD_Add_Arm_B     : constant Win.Command_Id_Type := 421;
  ID_SD_Sub_Arm_B     : constant Win.Command_Id_Type := 422;
  ID_SD_Shaft_Pos     : constant Win.Command_Id_Type := 423;
  ID_SD_Move_Shaft    : constant Win.Command_Id_Type := 424;
  ID_SD_UP            : constant Win.Command_Id_Type := 425;
  ID_SD_Down          : constant Win.Command_Id_Type := 426;
  ID_SD_Right         : constant Win.Command_Id_Type := 427;
  ID_SD_Left          : constant Win.Command_Id_Type := 428;
  ID_SD_Shaft_B       : constant Win.Command_Id_Type := 429;
  ID_SD_Set_Shaft_B   : constant Win.Command_Id_Type := 430;
  ID_SD_Inc           : constant Win.Command_Id_Type := 431;
  ID_SD_Dec           : constant Win.Command_Id_Type := 432;


  Font_Att    : Gpi.Font_Attributes_Type;
  Font_Status : Gpi.Font_Status_Type; 

  Font_Id     : Gpi.LCID_Type := Gpi.LCID_Default;

  Ps_ID       : Gpi.Ps_Id_Type;

  Obj_Buf    : Dos.Object_Buffer_Type (1 .. 100);
  Empty_Str  : String (1 .. 1) := " ";
  Results    : Dos.Result_Codes_Type;
  Run_Pgm    : String (1 .. 22) := "c:\pm_binding\menu.exe";  
  Dos_Result : Dos.Api_Return_Code;
  Launch     : Boolean := False;

  Y_Point    : Win.Pixel_Type := 300;

  New_Window     : Win.Handle_Type;
  New_Scroll_Bar : Win.Handle_Type; 

  Clear_Str      : String (1 .. 100) := (others => ' ');

  ------------------------------------------------------------------
 
   procedure Draw_Arcs (Window : Win.Handle_Type) is
      Ps           : Win.Ps_Type; 
     begin

       Ps := Win.Get_Ps (Window);

       GPI.Set_Background_Mix (Ps, GPI.Bm_Overpaint);
       GPI.Set_Background_Color (Ps, Win.Clr_Background);
       GPI.Set_Color (Ps, Win.Clr_Blue);
       GPI.Char_String_At (
                              Ps    => Ps,
                              Point => (400, 350),
                              Text  => "Arcs");
          
            --A Circle
       GPI.Set_Color (Ps, Win.Clr_White);
       Gpi.Full_Arc (
                 Ps            => Ps,
                 Center        => (420, 75),
                 Arc_Params    => (1, 1, 0, 0), 
                 Outline_Style => Gpi.Dro_Outline,
                 Multiplier    => 50);

            --A Width Ellipse
       GPI.Set_Color (Ps, Win.Clr_Brown);
       Gpi.Full_Arc (
                 Ps            => Ps,
                 Center        => (420, 200),
                 Arc_Params    => (1, 2, 0, 0), 
                 Outline_Style => Gpi.Dro_Fill,
                 Multiplier    => 25);

            --A Tall Ellipse
       GPI.Set_Color (Ps, Win.Clr_Yellow);
       Gpi.Full_Arc (
                 Ps            => Ps,
                 Center        => (420, 305),
                 Arc_Params    => (2, 1, 0, 0), 
                 Outline_Style => Gpi.Dro_Outline_Fill,
                 Multiplier    => 25);

       Win.Release_Ps (Ps);
    end Draw_Arcs;

  ------------------------------------------------------------------

    procedure Draw_Rectangles (Window : in Win.Handle_Type) is
        Ps           : Win.Ps_Type; 
      begin

        Ps := Win.Get_Ps (Window);

        GPI.Set_Background_Mix (Ps, GPI.Bm_Overpaint);
        GPI.Set_Background_Color (Ps, Win.Clr_Background);
        GPI.Set_Color (Ps, Win.Clr_Blue);
        GPI.Char_String_At (
                              Ps    => Ps,
                              Point => (200, 350),
                              Text  => "Rectangles");
          
        GPI.Set_Color (Ps, Win.Clr_Red);
        Gpi.Box (Ps            => Ps,
                    Start_Corner    => (200, 50),
                    End_Corner      => (300, 125),
                    Outline_Style   => Gpi.Dro_Fill,
                    Horz_Rounding   => 0,
                    Vert_Rounding   => 0);

        GPI.Set_Color (Ps, Win.Clr_Blue);
        Gpi.Box (Ps            => Ps,
                    Start_Corner  => (200, 175),
                    End_Corner    => (300, 250),
                    Outline_Style => Gpi.Dro_Outline,
                    Horz_Rounding => 10,
                    Vert_Rounding => 10);
                    
        GPI.Set_Color (Ps, Win.Clr_Dark_Green);
        Gpi.Box (Ps            => Ps,
                    Start_Corner  => (200, 265),
                    End_Corner    => (300, 340),
                    Outline_Style => Gpi.Dro_Outline_Fill,
                    Horz_Rounding => 30,
                    Vert_Rounding => 30);

        Win.Release_Ps (Ps);

   end Draw_Rectangles;

  -------------------------------------------------------

   procedure Draw_Lines (Window : in Win.Handle_Type) is
        Ps           : Win.Ps_Type; 

       use Win;
     begin

       Ps := Win.Get_Ps (Window);

       GPI.Set_Background_Mix (Ps, GPI.Bm_Overpaint);
       GPI.Set_Background_Color (Ps, Win.Clr_Background);
       GPI.Set_Color (Ps, Win.Clr_Blue);
       GPI.Char_String_At (
                           Ps    => Ps,
                           Point => (60, 350),
                           Text  => "Lines");
          
       GPI.Set_Color (Ps, Win.Clr_Pink);

       for I in 1 .. 35 loop
          GPI.Line (Ps          => Ps,
                    Start_Point => (50, 50),
                    End_Point   => (X => 150 - (Win.Pixel_Type (I) * 3), 
                                    Y => 70 + (Win.Pixel_Type (I) * 8)));
       end loop;

       Win.Release_Ps (Ps);

   end Draw_Lines;

  ------------------------------------------------------------------

    procedure Check_Menu_Item (Item_Id    : in Win.Command_ID_Type;
                               By_Pointer : in Boolean) is
 
      Menu    : Win.Menu_Type := Win.Null_Menu;
      Result         : Boolean;

    begin

      Menu := Win.Menu_Is (Frame_Win);

      Result      := Win.Check_Menu_Item (
                       Menu    => Menu,
                       Item_Id => Item_Id,
                       Check   => By_Pointer);

      Result      := Win.Enable_Menu_Item (
                       Menu     => Menu,
                       Item_Id  => Item_Id,
                       Enable   => By_Pointer);

    end Check_Menu_Item;

  ------------------------------------------------------------------

    procedure Erase_Screen (Window : in Win.Handle_Type) is 
        Ps : Win.Ps_Type; 
     begin

       Y_Point := 300;

       Ps := Win.Get_Ps (Window);
       Gpi.Erase (Ps);
       Win.Release_Ps (Ps);

     end Erase_Screen;

  ------------------------------------------------------------------

    procedure Toggle_Check (For_Id : Win.Command_Id_Type) is
 
      Menu    : Win.Menu_Type := Win.Null_Menu;
      Result         : Boolean;

    begin

      Menu := Win.Menu_Is (Frame_Win);

      Result      := Win.Check_Menu_Item (
                          Menu => Menu,
                          Item_Id => For_Id,
                          Check   => not (       
                                     Win.Is_Menu_Item_Checked (Menu    => Menu,
                                                               Item_Id => For_Id)));
    end Toggle_Check;

  ------------------------------------------------------------------

    procedure Toggle_State (For_Id : Win.Command_Id_Type) is
 
      Menu    : Win.Menu_Type := Win.Null_Menu;
      Result         : Boolean;

    begin

      Menu := Win.Menu_Is (Frame_Win);

      Result      := Win.Enable_Menu_Item (
                          Menu    => Menu,
                          Item_Id => For_Id,
                          Enable  => not (       
                                     Win.Is_Menu_Item_Enabled (Menu    => Menu,
                                                               Item_Id => For_Id)));
    end Toggle_State;

  ------------------------------------------------------------------

   procedure Write_Message (Window  : in Win.Handle_Type;
                            Message : in String) is 

    Ps           : Win.Ps_Type; 

    Options      : Win.Pop_Up_Options_Type;
    Filler       : Integer;

    use Win;
    use GPI;
   begin

--     Text_Io.Put_Line ("Message => " & Message);

           if Y_Point < 30 then
              Y_Point := 300;
           else
              Y_Point := Y_Point - 20;
           end if;

           if Message'length < Clear_Str'length then
              Filler := Clear_Str'length - Message'length;
           else
              Filler := 0;
           end if;

--           if Font_Id = Gpi.LCID_Default then
             Ps := Win.Get_Ps (Window);
--           else
--             Ps := Win.Get_Ps (Window);
--             Gpi.Restore (Ps, Ps_Id);
--             Gpi.Set_Char_Set (
--                 Ps        => Ps,
--                 Local_Id  => Font_Id); 
--           end if;
       
           GPI.Set_Background_Mix (Ps, GPI.Bm_Overpaint);
           GPI.Set_Background_Color (Ps, Win.Clr_Background);
           GPI.Set_Color (Ps, Win.Clr_Blue);
           GPI.Char_String_At (
                              Ps    => Ps,
                              Point => (10, Y_Point),
                              Text  => Message & Clear_Str (1 .. Filler));

--           if Font_Id = Gpi.LCID_Default then
             Win.Release_Ps (Ps);
--           else
--             Ps_Id := Gpi.Save (Ps);
--           end if;

   end Write_Message;

  ------------------------------------------------------------------

   procedure Load_A_Font (Window : Win.Handle_Type) is 
      Ps     : Win.Ps_Type; 
    begin

      Font_Att.Selections             := (others => False);
      Font_Att.Match                  := 0;
      Font_Att.Registry               := 0;
      Font_Att.Code_Page              := 850;
      Font_Att.Max_Baseline_Extension := 12;
      Font_Att.Average_Char_Width     := 12;
      Font_Att.Type_of_Font           := (others => False);
      Font_Att.Usage                  := (Gpi.No_Mix => True, Others => False);
      
      Font_Att.Face_Name (1 .. 8)     := "Courier" & Ascii.Nul;

      Write_Message (Window  => Window,
                     Message => "Get Font");

      Ps := Win.Get_Ps (Window);

      Gpi.Create_Logical_Font (
                Ps         => Ps,
                Name       => "        ",
                Local_Id   => 1, 
                Attributes => Font_Att,
                Status     => Font_Status);

      Write_Message (Window  => Window,
                     Message => "Font Status => " & Gpi.Font_Status_Type'image (Font_Status));

      Gpi.Set_Char_Set (
               Ps        => Ps,
               Local_Id  => 1); 

      Text_Io.Put_Line ("Set Char Set");

      Ps_Id := Gpi.Save (Ps);

      Text_Io.Put_Line ("Saved PS");

--      Font_Id := 1;
             
      Write_Message (Window  => Window,
                     Message => "After character setting, is this bigger?");

      Gpi.Restore (Ps, Ps_Id);

      Text_Io.Put_Line ("Wrote Message");

      GPI.Char_String_At (
                          Ps    => Ps,
                          Point => (250, Y_Point),
                          Text  => "The Quick Brown Fox Jumped over the Lazy Brown Dog");

--      Win.Release_Ps (Ps);

      exception
        when Gpi.Gpi_Error => 
          Write_Message (Window  => Window,
                         Message => "Got GPI_Error");
          Win.Release_Ps (Ps);

   end Load_A_Font;

  ------------------------------------------------------------------

   function Create_A_Window (Parent_Window : Win.Handle_Type) return Win.Handle_Type is
      Win_Styles       : Win.Window_Styles_Type := (Others => False);
      Created_Window   : Win.Handle_Type;
      Created_Window_2 : Win.Handle_Type;
      Frame_Data       : Win.Frame_Control_Data_Type;

     begin

      Frame_CF := 
       (Win.Fcf_Title_Bar       => True,
        Win.Fcf_System_Menu     => False, --True,
        Win.Fcf_Min_Max         => False, --True,
        Win.Fcf_Sizing_Border   => True,
        Win.Fcf_Task_List       => False, --True,
        Win.Fcf_Menu            => False, --True,
        Win.Fcf_Accel_Table     => False, --True,
        Win.Fcf_Vert_Scroll_Bar => True,
        others                  => False);

      Win.Set_Frame_Control_Data (Frame_Control_Flags => Frame_Cf,
                                  Resource            => 0,
                                  Resource_Id         => 0,
                                  Frame_Control_Data  => Frame_Data);

      Win_Styles (Win.Ws_Visible)       := True;
      Win_Styles (Win.Ws_Sync_Paint)    := True;
      Win_Styles (Win.Ws_Clip_Children) := True;

      Created_Window := Win.Create_Window (
              Parent_Window        => Parent_Window,
              Window_Class    	   => Win.Wc_Frame,
              Window_Title  	   => " New Window " & Version,
              Window_Styles 	   => Win_Styles,
              Size          	   => (10, 100, 300, 100),
              Owner_Window         => Parent_Window,
              Insert_Behind_Window => Win.Top_Window,
              Id                   => 1,
              Control_Data         => Win.To_Control_Data (Frame_Data),
              Pres_Params          => Win.No_Pres_Params);

      if Win.Is_Null (Created_Window) then
         Write_Message (Parent_Window, "Frame Failed");
         return Win.Null_Window;
      end if;         

      Win_Styles (Win.Ws_Sync_Paint)    := False;
      Win_Styles (Win.Ws_Clip_Children) := False;

      Created_Window_2 := Win.Create_Window (
              Parent_Window        => Created_Window,
              Class_Name    	   => "My_Window_Class",
              Window_Title  	   => "New Window " & Version,
              Window_Styles 	   => Win_Styles,
              Size          	   => (0, 0, 0, 0),
              Owner_Window         => Created_Window,
              Insert_Behind_Window => Win.Top_Window,
              Id                   => 16#8008#,
              Control_Data         => Win.No_Control_Data,
              Pres_Params          => Win.No_Pres_Params);

      if Win.Is_Null (Created_Window_2) then
         Write_Message (Parent_Window, "Client Failed");
         return Win.Null_Window;
      end if;         

       Win.Set_Window_Position (
               Window           => Created_Window,
               Behind_Window    => Win.Top_Window,
               X                => 10,
               Y                => 10,
               Width            => 300,
               Height           => 100,
               Position_Options => Win.Show_Window_cnt);

      return Created_Window;

      exception
        when Win.Set_Failed =>
         Write_Message (Parent_Window, "Set Failed" );

         return Created_Window;

        when others => 
         Write_Message (Parent_Window, "Exception raised " );

         return Win.Null_Window;
    end Create_A_Window;

  ------------------------------------------------------------------

   procedure Create_Slider (Parent_Window : Win.Handle_Type) is

      Slider_Style : Win.Slider_Style_Type;
      Slider_Data  : Win.Slider_Control_Data_Type;

      Index        : Integer := 0;

      At_Tick          : Pm_Types.U_Short;

      Pixels_From_Home : Win.Pixel_Type;
      Range_of_Pixels  : Win.Pixel_Type;

      Length           : Win.Pixel_Type;
      Breadth          : Win.Pixel_Type;

      X_Shaft          : Win.Pixel_Type;
      Y_Shaft          : Win.Pixel_Type;

     use Win;

     begin

       Slider_Data.Size               := Slider_Data'size / 8;
       Slider_Data.Scale_1_Increments := 6;
       Slider_Data.Scale_1_Spacing    := Win.Auto_Calculate_Spacing;

       Slider_Style := (others => False);

       Slider_Style (Win.SLS_Horizontal)      := True;
       Slider_Style (Win.SLS_Center)          := True;
       Slider_Style (Win.SLS_Home_Left)       := True;
       Slider_Style (Win.SLS_Primary_Scale_1) := True;
       Slider_Style (Win.SLS_Buttons_Right)   := True;

       Slider_Window := Win.Create_Slider (
                         Parent_Window => Parent_Window,
                         Style         => Slider_Style,
                         Size          => (300, 10, 200, 80),
                         Control_Data  => Slider_Data,
                         Id            => 26);  

       Win.Set_Tick_Marks (Slider            => Slider_Window,
                           Component_Message => Win.Sma_Set_All_Ticks,
                           Distance          => 6);  
      
       for I in 0 .. 5 loop
         Win.Set_Tick_Text (Slider => Slider_Window,
                            Tick   => Pm_Types.Short (I),
                            Text   => Integer'Image (Index));
         Index := Index + 10;
       end loop;

       Win.Add_Detent (Slider             => Slider_Window,
                       Distance_From_Home => 5); 

       Win.Add_Detent (Slider             => Slider_Window,
                       Distance_From_Home => 65); 

       Win.Set_Arm_Position (Slider  => Slider_Window,
                             At_Tick => 1);

       Win.Show_Slider (Slider  => Slider_Window,
                        Showing => True);

   end Create_Slider;

  ------------------------------------------------------------------

   procedure Create_A_Spin_Button (Parent_Window : Win.Handle_Type) is 

      Spin_Style       : Win.Spin_Button_Style_Type;

   begin

      Spin_Style := (others => False);

      Spin_Style (Win.Spbs_Master)        := True;
      Spin_Style (Win.Spbs_Numeric_Only)  := True;
      Spin_Style (Win.Spbs_Justify_Right) := True;
      Spin_Style (Win.Spbs_Fast_Spin)     := True;

      Spin_Button := Win.Create_Spin_Button (
                        Parent_Window => Parent_Window,
                        Style         => Spin_Style,
                        Size          => (60, 10,  150, 50),
                        Id            => 25);

      Win.Set_Limits (Spin_Button => Spin_Button,
                      Maximum     => 1000,
                      Minimum     => 0);

      Win.Set_Current_Value (Spin_Button => Spin_Button,
                             Value       => 252);

      Win.Show_Spin_Button (Spin_Button => Spin_Button,
                            Showing     => True);

   end Create_A_Spin_Button;

  ------------------------------------------------------------------

   function Create_A_Scroll_Bar (Parent_Window : Win.Handle_Type) return Win.Handle_Type is

      Win_Styles       : Win.Window_Styles_Type := (Others => False);
      Created_Window   : Win.Handle_Type;
      SB_Data          : Win.Scroll_Bar_Data_Type;

     begin
   
      Sb_Data.Size          := 14;
      Sb_Data.Hi_Lite       := 0;
      Sb_Data.First_Pos     := 200;
      Sb_Data.Last_Pos      := 400;
      Sb_Data.Thumb_Pos     := 300;
      Sb_Data.Visible_Items := 10;
      Sb_Data.Total_Items   := 100; 

      Win_Styles (Win.Ws_Visible) := True;
      Win_Styles (Win.Sbs_Vert)   := True;

      Created_Window := Win.Create_Window (
              Parent_Window        => Parent_Window,
              Window_Class    	   => Win.Wc_Scroll_Bar,
              Window_Title  	   => "", 
              Window_Styles 	   => Win_Styles,
              Size          	   => (10, 10, 20, 120),
              Owner_Window         => Parent_Window,
              Insert_Behind_Window => Win.Top_Window,
              Id                   => 1,
              Control_Data         => Win.To_Control_Data (Sb_Data),
              Pres_Params          => Win.No_Pres_Params);

      if Win.Is_Null (Created_Window) then
         Write_Message (Parent_Window, "Scroll Bar Failed");
         return Win.Null_Window;
      end if;         

      return Created_Window;

     end Create_A_Scroll_Bar;

  ------------------------------------------------------------------

   procedure Process_Spin_Button (Command_Id : in Win.Command_Id_Type;
                                  For_Window : in Win.Handle_Type) is

       Max : Pm_Types.Long;
       Min : Pm_Types.Long;

       At_Tick          : Pm_Types.U_Short;
 
       Pixels_From_Home : Win.Pixel_Type;
       Range_of_Pixels  : Win.Pixel_Type;

      use Win;
    begin

     case Command_Id is

       when ID_Create_Spin_Button =>

         if Win.Is_Null (Spin_Button) then
            Create_A_Spin_Button (For_Window);
         end if;

       when ID_SB_Current_Value =>
            Write_Message (Window => For_Window,
                           Message => 
                  "Current Value => " 
                    & Pm_Types.Long'Image (
                        Win.Current_Value (Spin_Button)));
       
       when Id_Sb_Current_Limits =>
             
            Win.Current_Limits (Spin_Button, Max, Min);

            Write_Message (Window => For_Window,
                           Message => "Limits, Min => "
                                & Pm_Types.Long'Image (Min)
                                 & ", Max => " 
                                   & Pm_Types.Long'Image (Max));
          
       when ID_Sb_Up_1 => 
            Win.Spin_Up (Spin_Button, 1);

       when ID_Sb_Up_10 => 
            Win.Spin_Up (Spin_Button, 10);

       when ID_Sb_Down_1 => 
            Win.Spin_Down (Spin_Button, 1);

       when ID_Sb_Down_10 => 
            Win.Spin_Down (Spin_Button, 10);

       when others => null;
     end case;
   end Process_Spin_Button;

  ------------------------------------------------------------------

   procedure Process_Slider (Command_Id : in Win.Command_Id_Type;
                             For_Window : in Win.Handle_Type) is

      Index            : Integer := 0;

      At_Tick          : Pm_Types.U_Short;

      Pixels_From_Home : Win.Pixel_Type;
      Range_of_Pixels  : Win.Pixel_Type;

      Length           : Win.Pixel_Type;
      Breadth          : Win.Pixel_Type;

      X_Shaft          : Win.Pixel_Type;
      Y_Shaft          : Win.Pixel_Type;

     use Win;
     begin

      case Command_Id is
        when ID_SD_Create        => 
           if Win.Is_Null (Slider_Window) then
              Create_Slider (For_Window);
           end if;

        when ID_SD_At_Tick       =>

           Win.Query_Arm_Position (Slider_Window, At_Tick); 

           Write_Message (Window => For_Window,
                          Message => "Arm Tick Position => " 
                                       & Pm_Types.U_Short'image (At_Tick));

        when ID_SD_Tick_0        =>

             Win.Set_Arm_Position (Slider  => Slider_Window,
                                   At_Tick => 0);

        when ID_SD_Tick_10       =>

             Win.Set_Arm_Position (Slider  => Slider_Window,
                                   At_Tick => 1);

        when ID_SD_Tick_20       =>

             Win.Set_Arm_Position (Slider  => Slider_Window,
                                   At_Tick => 2);

        when ID_SD_Tick_30       =>

             Win.Set_Arm_Position (Slider  => Slider_Window,
                                   At_Tick => 3);

        when ID_SD_Tick_40       =>

             Win.Set_Arm_Position (Slider  => Slider_Window,
                                   At_Tick => 4);

        when ID_SD_Tick_50       =>

             Win.Set_Arm_Position (Slider  => Slider_Window,
                                   At_Tick => 5);

        when ID_SD_At_Percent    =>

          Win.Query_Arm_Position (Slider           => Slider_Window,
                                  Pixels_From_Home => Pixels_From_Home,
                                  Range_of_Pixels  => Range_of_Pixels);

          Write_Message (Window  => For_Window, 
                     Message => "Arm Pixel Position => "
                       & Win.Pixel_Type'Image (Pixels_From_Home)
                        & ", Range => " 
                         & Win.Pixel_Type'Image (Range_of_Pixels)
                          & ", Scale Value => " 
                           & Win.Pixel_Type'Image ((50 * Pixels_From_Home) / Range_of_Pixels)); 

        when ID_SD_0_Percent     =>

             Win.Set_Arm_Position (Slider   => Slider_Window,
                                   At_Range => 0);

        when ID_SD_25_Percent    => 

             Win.Query_Arm_Position (Slider           => Slider_Window,
                                     Pixels_From_Home => Pixels_From_Home,
                                     Range_of_Pixels  => Range_of_Pixels);

             Win.Set_Arm_Position (Slider   => Slider_Window,
                                   At_Range => Range_of_Pixels * 25 / 100); 

        when ID_SD_50_Percent    =>

             Win.Query_Arm_Position (Slider           => Slider_Window,
                                     Pixels_From_Home => Pixels_From_Home,
                                     Range_of_Pixels  => Range_of_Pixels);

             Win.Set_Arm_Position (Slider   => Slider_Window,
                                   At_Range => Range_of_Pixels * 50 / 100); 

        when ID_SD_75_Percent    =>

             Win.Query_Arm_Position (Slider           => Slider_Window,
                                     Pixels_From_Home => Pixels_From_Home,
                                     Range_of_Pixels  => Range_of_Pixels);

             Win.Set_Arm_Position (Slider   => Slider_Window,
                                   At_Range => Range_of_Pixels * 75 / 100); 

        when ID_SD_100_Percent   =>

             Win.Query_Arm_Position (Slider           => Slider_Window,
                                     Pixels_From_Home => Pixels_From_Home,
                                     Range_of_Pixels  => Range_of_Pixels);

             Win.Set_Arm_Position (Slider   => Slider_Window,
                                   At_Range => Range_of_Pixels); 

        when ID_SD_Arm_Size      =>

          Win.Query_Arm_Size (Slider  => Slider_Window,
                              Length  => Length,
                              Breadth => Breadth);      

          Write_Message (Window  => For_Window, 
                        Message => "Arm Size: Length => "
                         & Win.Pixel_Type'Image (Length)
                          & ", Breadth => "
                           & Win.Pixel_Type'Image (Breadth));
  
        when ID_SD_Add_Arm_L     =>

          Win.Query_Arm_Size (Slider  => Slider_Window,
                              Length  => Length,
                              Breadth => Breadth);      

          Win.Set_Arm_Size (Slider  => Slider_Window,
                            Length  => Length + 1,
                            Breadth => Breadth);

        when ID_SD_Sub_Arm_L     =>

          Win.Query_Arm_Size (Slider  => Slider_Window,
                              Length  => Length,
                              Breadth => Breadth);      

          Win.Set_Arm_Size (Slider  => Slider_Window,
                            Length  => Length - 1,
                            Breadth => Breadth);

        when ID_SD_Add_Arm_B     =>

          Win.Query_Arm_Size (Slider  => Slider_Window,
                              Length  => Length,
                              Breadth => Breadth);      

          Win.Set_Arm_Size (Slider  => Slider_Window,
                            Length  => Length,
                            Breadth => Breadth + 1);

        when ID_SD_Sub_Arm_B     =>

          Win.Query_Arm_Size (Slider  => Slider_Window,
                              Length  => Length,
                              Breadth => Breadth);      

          Win.Set_Arm_Size (Slider  => Slider_Window,
                            Length  => Length,
                            Breadth => Breadth - 1);

        when ID_SD_Shaft_Pos     =>

          Win.Query_Shaft_Positions (Slider  => Slider_Window,
                                     X_Shaft => X_Shaft,
                                     Y_Shaft => Y_Shaft); 

          Write_Message (Window  => For_Window, 
                     Message => "Sahft Position: X => "
                       & Win.Pixel_Type'Image (X_Shaft)
                        & ", Y => "
                         & Win.Pixel_Type'Image (Y_Shaft));

        when ID_SD_UP            =>

          Win.Query_Shaft_Positions (Slider  => Slider_Window,
                                     X_Shaft => X_Shaft,
                                     Y_Shaft => Y_Shaft);

          Win.Set_Shaft_Positions (Slider => Slider_Window,
                                   X_Shaft => X_Shaft,
                                   Y_Shaft => Y_Shaft + 1);

        when ID_SD_Down          =>

          Win.Query_Shaft_Positions (Slider  => Slider_Window,
                                     X_Shaft => X_Shaft,
                                     Y_Shaft => Y_Shaft);

          Win.Set_Shaft_Positions (Slider => Slider_Window,
                                   X_Shaft => X_Shaft,
                                   Y_Shaft => Y_Shaft - 1);

        when ID_SD_Right         =>

          Win.Query_Shaft_Positions (Slider  => Slider_Window,
                                     X_Shaft => X_Shaft,
                                     Y_Shaft => Y_Shaft);

          Win.Set_Shaft_Positions (Slider => Slider_Window,
                                   X_Shaft => X_Shaft + 1,
                                   Y_Shaft => Y_Shaft);

        when ID_SD_Left          =>

          Win.Query_Shaft_Positions (Slider  => Slider_Window,
                                     X_Shaft => X_Shaft,
                                     Y_Shaft => Y_Shaft);

          Win.Set_Shaft_Positions (Slider => Slider_Window,
                                   X_Shaft => X_Shaft - 1,
                                   Y_Shaft => Y_Shaft);

        when ID_SD_Shaft_B       =>

          Win.Query_Shaft_Dimensions (Slider  => Slider_Window,
                                      Length  => Length,
                                      Breadth => Breadth);      

          Write_Message (Window  => For_Window, 
                     Message => "Shaft Dimensions: Length => "
                       & Win.Pixel_Type'Image (Length)
                        & ", Breadth => "
                         & Win.Pixel_Type'Image (Breadth));

        when ID_SD_Inc           =>

          Win.Query_Shaft_Dimensions (Slider  => Slider_Window,
                                      Length  => Length,
                                      Breadth => Breadth);      

          Win.Set_Shaft_Breadth (Slider => Slider_Window,
                                 Breadth => Breadth + 1);

        when ID_SD_Dec           =>

          Win.Query_Shaft_Dimensions (Slider  => Slider_Window,
                                      Length  => Length,
                                      Breadth => Breadth);      

          Win.Set_Shaft_Breadth (Slider => Slider_Window,
                                 Breadth => Breadth - 1);

        when others              => null;
    end case;

  end Process_Slider;

  ------------------------------------------------------------------

   procedure Process_Menu (Command_Id : in Win.Command_Id_Type;
                           For_Window : in Win.Handle_Type;
                           By_Pointer : in Boolean) is

       Menu : Win.Menu_Type := Win.Null_Menu;
       Result      : Boolean;
     begin


       case Command_Id is

         when Id_New_Window  => New_Window := Create_A_Window (For_Window);
                                Toggle_State (For_Id => Id_New_Window);

         when Id_Scroll_Bar  => New_Scroll_Bar := Create_A_Scroll_Bar (For_Window);
                                Toggle_State (For_Id => Id_Scroll_Bar);

         when Id_Lines       => Draw_Lines (For_Window);
         when Id_Arcs        => Draw_Arcs  (For_Window);
         when Id_Rectangles  => Draw_Rectangles (For_Window);

         when Id_Check_Lines      => Toggle_Check (For_Id => Id_Lines);
         when Id_Check_Arcs       => Toggle_Check (For_Id => Id_Arcs);
         when Id_Check_Rectangles => Toggle_Check (For_Id => Id_Rectangles);

         when Id_State_Lines      => Toggle_State (For_Id => Id_Lines);
         when Id_State_Arcs       => Toggle_State (For_Id => Id_Arcs);
         when Id_State_Rectangles => Toggle_State (For_Id => Id_Rectangles);

         when Id_Spin_Button .. ID_SB_Down_10 =>
           Process_Spin_Button (Command_ID, For_Window);

         when Id_Slider .. ID_Sd_Dec => 
           Process_Slider (Command_Id, For_Window);
              
         when Id_Status     => 

           Menu := Win.Menu_Is (Frame_Win);

           Write_Message (Window  => For_Window,
                          Message => "Line is Enabled " &                                     
                                        Boolean'Image (
                                           Win.Is_Menu_Item_Enabled (
                                                 Menu    => Menu,
                                                 Item_Id => Id_Lines)));

         when Id_Clear      => Erase_Screen (For_Window);

         when others        => null;
       end case;

     end Process_Menu;


  ------------------------------------------------------------------

   procedure Process_Vertical_Scroll_Bar (Window : in Win.Handle_Type;
                                          Mp1    : in Win.Parameter_Type;
                                          Mp2    : in Win.Parameter_Type) is

      Sb_Data : Win.Scroll_Bar_Command_Data_Type;
      Skip    : Boolean := False;

      F_Win   : Win.Handle_Type;
      VSB     : Win.Scroll_Bar_Type;

      Str     : String (1 .. 40);
      Size    : Integer;
      Class   : Win.Window_Class_Type;

      use Pm_Types;
     begin

       Sb_Data := WIn.Scroll_Bar_Command_Is (Mp1, Mp2);

      if Sb_Data.Id = 1 then --The stand alone Scroll Bar
        VSB := Win.Window_To_Scroll_Bar (New_Scroll_Bar);
        Win.Query_Class_Name (
                Window => New_Scroll_Bar,
                Name   => Str,
                Size   => Size,
                Class  => Class);

--        Write_Message (Window, "Class is => " & Str (1 .. Size));

      else
        VSB := Win.Vertical_Scroll_Bar_Is (Window);         
      end if;

      if Win.Is_Null (VSB) then
         F_Win := Win.Query_Window (Window, Win.Qw_Parent);
         VSB   := Win.Vertical_Scroll_Bar_Is (F_Win);
      end if;

      if not Win.Is_Null (VSB) then
        Sb_Data.Position := Win.Query_Scroll_Bar_Position (VSB);

        Write_Message (Window, "Command is => "  
                                & Win.Scroll_Bar_Command_Type'Image (Sb_Data.Command) 
                                 & " Position is => " 
                                  & Pm_Types.Short'Image (Sb_Data.Position)
                                   & " Id is => "
                                    & Pm_Types.U_Short'Image (Sb_Data.Id));
         case Sb_Data.Command is
           when Win.Sb_Line_Up         => 

              if Sb_Data.Position > 1 then
                 Sb_Data.Position := Sb_Data.Position - 1;
              end if;

           when Win.Sb_Line_Down       => 

              if Sb_Data.Position < Pm_Types.Short'last then
                 Sb_Data.Position := Sb_Data.Position + 1;
              end if;

           when Win.Sb_Page_Up         => 

              if Sb_Data.Position > 10 then
                 Sb_Data.Position := Sb_Data.Position - 10;
              else
                 Sb_Data.Position := 1;
              end if;

           when Win.Sb_Page_Down       =>

              if Sb_Data.Position < Pm_Types.Short'last - 10 then
                 Sb_Data.Position := Sb_Data.Position + 10;
              else
                 Sb_Data.Position := Pm_Types.Short'last;
              end if;

           when Win.Sb_Slider_Track    =>  
              null;

           when Win.Sb_Slider_Position => 
              null;

           when Win.Sb_End_Scroll      => 
              Skip := True;

           when others                 => null;
         end case;

         if not Skip then
           Win.Set_Scroll_Bar_Thumb_Position (Scroll_Bar => VSB,
                                              Position   => Sb_Data.Position);
         end if;
      end if;

     end Process_Vertical_Scroll_Bar;

  ------------------------------------------------------------------

  function Win_Test_Handler (Window  : Win.Handle_Type;
                             Message : Win.Message_Type;
                             MP1     : Win.Parameter_Type;
                             MP2     : Win.Parameter_Type) 
                                           return Pm_Types.U_Long is
    Result       : Boolean;
    Ps           : Win.Ps_Type; 
    Paint_Hps    : Win.Ps_Type; 

    Str          : String (1 .. 1);

    Gpi_Results  : Gpi.Status_Type;
    Command_Info : Win.Command_Info_Type;

    Point        : Win.Point_Type;
    Options      : Win.Pop_Up_Options_Type;
 
    Paint_Rect   : Win.Rectangle_Type;

    use Win;
   begin

     case Message is

      when Win.Wm_Button_1_Down => 
           
           Ps := Win.Get_Ps (Window);
           GPI.Set_Background_Mix (Ps, GPI.Bm_Overpaint);
           GPI.Set_Background_Color (Ps, Win.Clr_Background);
           GPI.Set_Color (Ps, Win.Clr_Blue);
           GPI.Char_String_At (
                              Ps    => Ps,
                              Point => Win.Pointer_Is (MP1),
                              Text  => Title & " Program Version " & Version);
           Win.Release_Ps (Ps);

           return 1;

      when Win.Wm_Button_2_Down => 

            if Win.Is_Null (Pop_Up_Menu) then
               Pop_Up_Menu := Win.Load_Menu (
                               Owner_Window => Window,
                               Resource     => Null,
                               Menu_Id      => ID_Pop_Up); 
            end if;

            if Win.Is_Null (Pop_Up_Menu) then
               Text_io.Put_Line ("Pop menu does not exist");
            else

               Options := (others => False);
               Options (Win.Pu_Position_On_Item) := True;
               Options (Win.Pu_Mouse_Button_1)   := True;
               Options (Win.Pu_Keyboard)         := True;

               Point   := Win.Pointer_Is (MP1);

               Result := Win.Pop_Up_Menu (
                     Window       => Window,
                     Frame_Window => Frame_Win,
                     Menu         => Pop_Up_Menu,
                     X            => Point.X,
                     Y            => Point.Y,
                     Item_Id      => Id_Arcs,
                     Options      => Options);

               if Result then 
                  Text_Io.Put_Line ("It should have worked");
               else
                  Text_Io.Put_Line ("It Failed");
               end if;

            end if;

            return 1;

      when Win.Wm_Char => 
           Key_Info := Win.Key_Info_Is (Mp1, Mp2);

           if (Key_Info.Flags (Win.Kc_Char) and then
               not Key_Info.Flags (Win.Kc_Virtual_Key)) or else
                (Key_Info.Flags (Win.Kc_Virtual_Key) and then
                   Key_Info.Virtual_Key = Win.Vk_Space and then
                    not Key_Info.Flags (Win.Kc_Key_Up)) then

             Str (1) := Character'Val (Integer (Key_Info.Character_Code));

             Ps := Win.Get_Ps (Window);

             GPI.Set_Background_Mix (Ps, GPI.Bm_Overpaint);
             GPI.Set_Background_Color (Ps, Win.Clr_Background);
             GPI.Char_String_At (
                              Ps    => Ps,
                              Point => Point,
                              Text  => Str);
             Win.Release_Ps (Ps);

             Point.X := Point.X + 11;

             if Point.X > 200 then
                Point.X := 10;
                Point.Y := Point.Y - 18;
             end if;

           elsif key_Info.Flags (Win.Kc_Virtual_Key) and then
                 not Key_Info.Flags (Win.Kc_Key_Up) then
             null;
           end if;

           return Win.Default_Window_Procedure (Window, Message, Mp1, Mp2);

      when Win.Wm_V_Scroll =>

           Process_Vertical_Scroll_Bar (Window, Mp1, Mp2);
           return 1;

      when Win.Wm_Command => 

         Command_Info := Win.Command_Info_Is (Mp1, Mp2);

         case Command_Info.Source is

           when Win.Cmd_Src_Menu =>
             Process_Menu (Command_Info.Id, Window, Command_Info.By_Pointer);

           when Win.Cmd_Src_Accelerator =>
             Process_Menu (Command_Info.Id, Window, Command_Info.By_Pointer);

           when others => null;
         end case;

  
         return 1;

      when Win.Wm_Erase_Background => 
           Erase_Screen (Window);
           return 1;
    
      when Win.Wm_Paint =>
           Win.Begin_Paint (Window    => Window,
                            Hps       => Win.Null_Ps,
                            Rectangle => Paint_Rect,
                            Paint_Hps => Paint_Hps); 

           Win.Fill_Rectangle (Hps       => Paint_Hps,
                               Rectangle => Paint_Rect,
                               Color     => Win.Clr_Background);

           Win.End_Paint (Paint_Hps);

           return Win.Default_Window_Procedure (Window, Message, Mp1, Mp2);

      when Win.Wm_Close =>
        Result := Win.Post_Message (Window, Win.Wm_Quit, 0, 0);

      when others => 
            return Win.Default_Window_Procedure (Window, Message, Mp1, Mp2);
     end case;

     return 0;

   end Win_Test_Handler; 

  ------------------------------------------------------------------

   procedure Show_Error (Message : String) is
     begin
       Button_Pressed := Win.Message_Box (
                        Parent_Window  => Win.Desktop_Window,
                        Request_Owner  => Win.Null_Window,
                        Message        => Message,
                        Title          => " Error ",
                        Help_Id        => 1,
                        Buttons        => Win.MB_Ok,
                        Icons          => Win.Mb_Icon_Hand, 
                        Default_Action => Win.Mb_Default_On_Button_1);
     end Show_Error;

  ------------------------------------------------------------------

   use Pm_Types;

  begin

    New_Win       := new Win.Handle_Type;
    Queue_Message := new Win.Queue_Message_Type;

    Win.Initialize (Win.System_Default, Hab);

    Win.Create_Message_Queue (Hab, Win.System_Default, Queue);    

    Window_Style (Win.Cs_Size_Redraw)   := True;
    Window_Style (Win.Cs_Clip_Children) := True;

    Win.Register_Class (
                        Anchor_Block    => Hab,
                        Class_Name      => "My_Window_Class",
                        Message_Handler => Win_Test_Handler'access,
                        Class_Style     => Window_Style,
                        Extra_Storage   => 0); 

    Frame_CF := 
       (Win.Fcf_Title_Bar       => True,
        Win.Fcf_System_Menu     => True,
        Win.Fcf_Min_Max         => True,
        Win.Fcf_Sizing_Border   => True,
        Win.Fcf_Task_List       => True,
        Win.Fcf_Menu            => True,
        Win.Fcf_Accel_Table     => True,
        Win.Fcf_Vert_Scroll_Bar => True,
        others                  => False);

    Frame_Win := Win.Create_Standard_Window (
             Parent_Window       => Win.Desktop_Window,
             Window_Styles       => Win.Use_Class_Styles,
             Frame_Control_Flags => Frame_CF,
             Class_Name          => "My_Window_Class",
             Window_Title        => Title & " program Version " & Version,
             Class_Style         => Window_Style,
             Resource            => null, 
             Resource_ID         => 200,
             New_Window          => New_Win);

    if Win.Is_Null (Frame_Win) then
       Show_Error ("The window was not created");
    else

       Win.Set_Window_Position (
               Window           => Frame_Win,
               Behind_Window    => Win.Top_Window,
               X                => 20,
               Y                => 20,
               Width            => 600,
               Height           => 430,
               Position_Options => Win.Show_Window_cnt);

       loop

          exit when not Win.Get_Message 
                         (Hab, Queue_Message, Win.Null_Window, 0, 0);

          Win.Dispatch_Message (Hab, Queue_Message);

       end loop;

    end if;

    Win.Destroy_Window (Frame_Win);
    Win.Destroy_Message_Queue (Queue);
    Win.Terminate_App (Hab);

  end Slider;
